-- Aircraft: Majestic Dash 8 Q-400
-- Version: 2.4
-- April 2016
-- Author: Capt. PERO, Helge Rassmusen, Guenter Steiner

-- ## System functions ##


function InitVars ()

    -- GSX
    ipc.set("GSXTanker", 0)
    ipc.set("GSXBoard", 0)
    ipc.set("GSXDeboard", 0)
    ipc.set("CatManCount1", 0)
    ipc.set("CatManCount2", 0)
    ipc.set("CatPhase1", 0)
    ipc.set("CatPhase2", 0)
    GSXRefuelTestTxt = 0

    -- uncomment to disable display
    -- AutopilotDisplayBlocked ()
    AutoDisplay = false
    ipc.sleep(100)
    --Q400_YOKE_VISIBILITY_off ()

    MJCD8_VS_Show ()
    MJCD8_ALT_Show ()
    MJCD8_HDG_Show ()
    MJCD8_SPD_Show ()

    ExtPwrTxt = 0
    ipc.set("CautAdvTest", 0)
    ipc.sleep(100)



    OnGround = ipc.readUW("0366")
    Tcount = 0
end 

-- copy Q400 landing gear position to FSX offsets
-- required for Saitek Switch Panel Landing Gear Lights
function MJCD8_CheckGearPos ()
local vGearHandle = ipc.readLvar("L:MAIN_GEAR_HANDLE_POS")
local vGearPosLeft = ipc.readLvar("L:FC_GEAR_POS_LEFT")
local vGearDoorLeft = ipc.readLvar("L:FC_GEAR_DOOR_POS_LEFT")
local vGearPosRight = ipc.readLvar("L:FC_GEAR_POS_RIGHT")
local vGearDoorRight = ipc.readLvar("L:FC_GEAR_DOOR_POS_RIGHT")
local vGearPosNose = ipc.readLvar("L:FC_GEAR_NOSE")
local vGearDoorNose = ipc.readLvar("L:FC_GEAR_DOOR_POS_NOSE")
local G_pos
local G_up = 0
local G_moving = 255
local G_down = 16383

    -- check Left Gear
    if (vGearPosLeft == 40) and (vGearDoorLeft == 0)
        then --and (vGearHandle == 0) then
        G_pos = G_up
    elseif (vGearPosLeft == 180) --and (vGearDoorLeft == 0)
        then --and (vGearHandle == 1)  then
        G_pos = G_down
    else
        G_pos = G_moving
    end
    -- save left gear position to FSX offset
    ipc.writeUW(0x0BF4, G_pos)

        -- check Right Gear
    if (vGearPosRight == 40) and (vGearDoorRight == 0)
        then --and (vGearHandle == 0)  then
        G_pos = G_up
    elseif (vGearPosRight == 180) --and (vGearDoorRight == 0)
        then --and (vGearHandle == 1)  then
        G_pos = G_down
    else
        G_pos = G_moving
    end
    -- save right gear position to FSX offset
    ipc.writeUW(0x0BF0, G_pos)

    -- check Nose Gear
    if (vGearPosNose ==40) and (vGearDoorNose == 0)
        then --and (vGearHandle == 0) then
        G_pos = G_up
    elseif (vGearPosNose == 100) --and (vGearDoorNose == 0)
        then --and (vGearHandle == 1)  then
        G_pos = G_down
    else
        G_pos = G_moving
    end
    -- save nose gear position to FSX offset
    ipc.writeUW(0x0BEC, G_pos)
end



function Timer ()

    GSX_Door_Service ()



    Tcount = Tcount + 1
    --_log('[awg] Tcount = ' .. Tcount)
    -- FD
    MJC_APstate = MJCD8_Read(31281)

    if MJC_APstate ~= 0 then
        DspFD(1)
    else
        DspFD(0)
    end


    -- Flaps
     local flaps = ipc.readLvar("Q400_FLAP_POS")
     if flaps == 0 then flaptxt = "up"
     elseif flaps == 1 then flaptxt = "05"
     elseif flaps == 2 then flaptxt = "10"
     elseif flaps == 3 then flaptxt = "15"
     elseif flaps == 4 then flaptxt = "35"
      end
     com.write(dev, "A/T"..flaptxt, 8) -- AP stby

    --------------

    MJCD8_VS_Show ()
    MJCD8_ALT_Show ()
    MJCD8_HDG_Show ()
    MJCD8_SPD_Show ()
    MJC_FlightInfo ()

    MJCD8_CheckGearPos()
end

function MJCD8_VS_Show ()
    MJCD8_vs = ipc.readUW(0x07F2)
    if MJCD8_vs > 32766 then
        MJCD8_vs = (65536 - MJCD8_vs) * -1
    end
    DspVVS(MJCD8_vs/100)
end

function MJCD8_ALT_Show ()
    ALT = round(ipc.readUD(0x07D4)/65536*3.28084/100)
	DspALT(ALT)
end

function MJCD8_HDG_Show ()
    HDG = round(ipc.readUW(0x07CC)*360/65536)
	DspHDG(HDG)
end

function MJCD8_CRS1_Show ()
    CRS = round(ipc.readLvar("GS_CRS1_KNOB_ANGLE") * 3.6)
	DspShow("CRS1", CRS)
end

function MJCD8_CRS2_Show ()
    CRS = round(ipc.readLvar("GS_CRS2_KNOB_ANGLE") * 3.6)
	DspShow("CRS2", CRS)
end

function MJCD8_SPD_Show ()
    SPD = ipc.readUW(0x07E2)
	DspSPD(SPD)
end

function MJC_FlightInfo ()
    OnGround = ipc.readUW("0366")
    -- Start Sequence Info
    StartSeqVar = ipc.readLvar("OHD_ENGSTART_SELECT_SW")  -- MJCD8_Read(35030)
    -- Cab Temp Info
    CabTempVar = round2(MJCD8_Read(61991)/2.55)
    -- APU Info
    APUFuelVar = MJCD8_Read(63766)
    APURunVar = MJCD8_Read(53579)

    if APUFuelVar == 0 and APURunVar == 0 then
        APUtxt2 = "off"
    elseif APUFuelVar ~= 0 and APURunVar == 0 then
        APUtxt2 = "sby"
        APUtxtShrt = "APU"
    elseif APUFuelVar ~= 0 and APURunVar ~= 0 then
        APUtxt2 = "run"
        APUtxtShrt = "APU"
    end
    -----------------------------------
    -- Flap Info
    FlapVar = MJCD8_Read(63780) -- Flaps lever

    if FlapVar == 0 then
        Flaptxt2 = "0"
    elseif FlapVar == 1 then
        Flaptxt2 = "5"
    elseif FlapVar == 2 then
        Flaptxt2 = "10"
    elseif FlapVar == 3 then
        Flaptxt2 = "15"
    elseif FlapVar == 4 then
        Flaptxt2 = "35"
    end

    -- external Power info
    ExtPowerVar = MJCD8_Read(41009) -- ext power
    ExtPwrSwVar = ipc.readLvar("OHD_DC_CNTRL_PNL_EXTPWR_SW")

    if ExtPowerVar == 1 and ExtPwrSwVar == 1 then
        ExtPwrTxt = "on"
        GPUtxtShrt = "GPU"
    elseif ExtPowerVar == 1 and ExtPwrSwVar == 0 then
        ExtPwrTxt = "conn"
        GPUtxtShrt = "GPU"
    elseif ExtPowerVar == 0 and ExtPwrSwVar == 0 then
        ExtPwrTxt = "off"
    end

    ------------------------------
    -- Condition Levers
    CL1 = ipc.readLvar("Q400_COND_LEVER_1")
    CL2 = ipc.readLvar("Q400_COND_LEVER_2")
    -- Throttle Position
    PWR1 = ipc.readLvar("Q400_Power_Lever_1")
    PWR2 = ipc.readLvar("Q400_Power_Lever_2")

    --_log('[awg] Pwr = ' .. PWR1 .. '=' ..PWR2)

    if CL1 == 0 then CL1txt = "--" elseif
      CL1 == 73 then CL1txt = "SF" elseif
      CL1 == 113 then CL1txt = "CR" elseif
      CL1 == 156 then CL1txt = "CL" elseif
      CL1 == 200 then CL1txt = "MX" end

    if CL2 == 0 then CL2txt = "--" elseif
      CL2 == 73 then CL2txt = "SF" elseif
      CL2 == 113 then CL2txt = "CR" elseif
      CL2 == 156 then CL2txt = "CL" elseif
      CL2 == 200 then CL2txt = "MX" end

    if PWR1 <= 45 then PWR1txt = "Min" elseif
        PWR1 <= 55 then PWR1txt = "Dis" elseif
        PWR1 <= 78 then PWR1txt = "Idl" elseif
        PWR1 >= 158 then PWR1txt = "Max" else
        PWR1txt = round(round((PWR1 - 70) * 1.05) - 0) .. " "
    end

    if PWR2 <= 45 then PWR2txt = "Min" elseif
        PWR2 <= 55 then PWR2txt = "Dis" elseif
        PWR2 <= 78 then PWR2txt = "Idl" elseif
        PWR2 >= 158 then PWR2txt = "Max" else
        PWR2txt = " " .. round((PWR2 - 70.0) * 1.05) - 0
    end

    -- Starting Sequence
    SelectLgrVar = MJCD8_Read(36500) -- if Start is pressed
    EngSelTxt = ""
    EngSelVar = ipc.readLvar("OHD_ENGSTART_SELECT_SW")
    if SelectLgtVar ~= 0 and EngSelVar ~= 0 then
        if EngSelVar == -1 then
            EngSelTxt = "L"
            EngRPMcode = 57868
        elseif EngSelVar == 1 then
            EngSelTxt = "R"
            EngRPMcode = 57891
        end
        StartLgtTxt = EngSelTxt .. " Sel"
    end

    StartLgtVar = MJCD8_Read(35030) -- when engine is selected

    -- GearPins
    GearPin = ipc.readLvar("Q400_GEAR_LOCK_PIN_IN")
    if GearPin == 1 then
    DspShow ("GEAR", "PIN!", "CHECK", "GEARPIN!")
    end

    -- get engine RPM
    EngRPM = round(MJCD8_Read(EngRPMcode)) -- when engine is selected

    if StartLgtVar ~= 0 and EngRPM >= 0 and EngSelTxt ~= nil then
        StartLgtTxt = EngSelTxt .. " NH" .. EngRPM .."%"
    end

    APUtxt = "APU " .. APUtxt2
    GPUtxt = "GPU " .. ExtPwrTxt
    Flaptxt = "Flap" .. Flaptxt2
    FlaptxtShrt = "F:" .. Flaptxt2
    CabTmpTxt = "Tmp " .. CabTempVar .."C"


    if _MCP2() then
        CondLevTxt = CL1txt .. " <> " .. CL2txt
        PwrLevTxt = PWR1txt .. "T%" .. PWR2txt
    elseif _MCP2a() then
        CondLevTxt = CL1txt .. "<>"..CL2txt
        PwrLevTxt = PWR1txt .. "%" .. PWR2txt
    else -- MCP1
        CondLevTxtShrtUp = "< " ..CL1txt
        CondLevTxtShrtLw = "> " ..CL2txt
    end

    if _MCP2() or _MCP2a() then
        -- flap position change
        if FlapVarLast ~= FlapVar then
            DspShow ("Flap", Flaptxt2)
        end
        FlapVarLast = FlapVar

        -- APU and Engine Start
        if StartSeqVar ~= 0 and APUFuelVar > 0 then
            UpTxtLong = APUtxt
            LwTxtLong = StartLgtTxt
        -- GPU and Engine Start
        elseif StartSeqVar ~= 0 and ExtPowerVar > 0 then
            UpTxtLong = GPUtxt
            LwTxtLong = StartLgtTxt
        -- ExtPwr and APU
        elseif ExtPowerVar > 0 and APUFuelVar > 0 then
            UpTxtLong = APUtxt
            LwTxtLong = GPUtxt
        -- APU and Temp
        elseif APUFuelVar > 0 and FlapVar == 0 then
            UpTxtLong = APUtxt
            LwTxtLong = CabTmpTxt
        -- APU and Flap
        elseif APUFuelVar > 0 and FlapVar > 0 then
            UpTxtLong = APUtxt
            LwTxtLong = Flaptxt
        -- ExtPwr and Flap
        elseif ExtPowerVar > 0 and FlapVar > 0 then
            UpTxtLong = GPUtxt
            LwTxtLong = Flaptxt
        -- Ext Pwr and Temp
        elseif ExtPowerVar > 0 then
            UpTxtLong = GPUtxt
            LwTxtLong = CabTmpTxt
        else
        -- Power and Condition Levers
            UpTxtLong = CondLevTxt
            LwTxtLong = PwrLevTxt



        end

        FLIGHT_INFO1 = UpTxtLong
        FLIGHT_INFO2 = LwTxtLong

    ---- if MCP 1
    else
        -- flap position change
        if FlapVarLast ~= FlapVar then
            DspShow ("F:", Flaptxt2)
        end
        FlapVarLast = FlapVar

      -- ExtPwr and APU
        if ExtPowerVar > 0 and APUFuelVar > 0 then
            UpTxtShort = APUtxtShrt
            LwTxtShort = GPUtxtShrt
        -- Engine start
        elseif StartSeqVar ~= 0 then
            UpTxtShort = CondLevTxtShrtUp
            LwTxtShort = CondLevTxtShrtLw
        -- APU
        elseif APUFuelVar > 0 and FlapVar == 0 then
            UpTxtShort = APUtxtShrt
            LwTxtShort = "    "
        -- ExtPwr and Flap
        elseif ExtPowerVar > 0 and FlapVar > 0 then
            UpTxtShort = GPUtxtShrt
            LwTxtShort = FlaptxtShrt
        -- APU and Flap
        elseif APUFuelVar > 0 and FlapVar > 0 then
            UpTxtShort = APUtxtShrt
            LwTxtShort = FlaptxtShrt
        --[[-- Flaps
        elseif FlapVar > 0 then
            UpTxtShort = FlaptxtShrt
            LwTxtShort = "    "
        --]]
        -- Ext Pwr
        elseif ExtPowerVar > 0 then
            UpTxtShort = GPUtxtShrt
            LwTxtShort = "    "
        -- CL
        elseif GearPin == 0 then
            UpTxtShort = CondLevTxtShrtUp
            LwTxtShort = CondLevTxtShrtLw

        else
            UpTxtShort = GearPinTxt
            LwTxtShort = GearPinTxt
        end

        FLIGHT_INFO1 = UpTxtShort
        FLIGHT_INFO2 = LwTxtShort
    end
end

---------------------------------------------------------------

-- Test Code for Development - DO NOT DELETE





function testWriteOff()
    MJCD8_Write(0,25110)
end

function testWriteOn()
    MJCD8_Write(1,25110)
end

function testWriteTest()
    MJCD8_Write(5000,57294)
end

function testRead()
    local val
    val = MJCD8_Read(41945)
    _log("testRead=" .. val)
    DspShow('Test', val)
end

function MJCD8_Write (val, code)
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", val)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", code)
end

function MJCD8_Read (code)
    local val
    ipc.writeLvar("MJC_VAR_READ_CODE", code)
    ipc.sleep(10)
    val = ipc.readLvar("MJC_VAR_READ_VALUE")
    return val
end

-- MJC Radio Development Code - DO NOT DELETE

function MJC_RADIOS_swap ()
	local buffer_s, buffer_x, mhz, khz
	-- COM radio
	if RADIOS_MODE == 1 then
		if RADIOS_SUBMODE == 1 then
			-- COM1
			--Default_COM_1_swap ()
			buffer_x = string.format("%04x", ipc.readUW(0x034E))
			buffer_s = string.format("%04x", ipc.readUW(0x311A))
            MJCD8_Write(buffer_x * 10, 34994)
		else
			-- COM2
			--Default_COM_2_swap ()
			buffer_x = string.format("%04x", ipc.readUW(0x3118))
			buffer_s = string.format("%04x", ipc.readUW(0x311C))
            MJCD8_Write(buffer_x * 10, 35015)
		end
        _log('[awg] MJC radio swap = ' .. buffer_x)
--[[	-- NAV
	elseif RADIOS_MODE == 2 then
		if RADIOS_SUBMODE == 1 then
			-- NAV1
			Default_NAV_1_swap ()
			buffer_x = string.format("%04x", ipc.readUW(0x0350))
			buffer_s = string.format("%04x", ipc.readUW(0x311E))
			ipc.sleep(20)
			com.write(dev, 'NAVx' .. buffer_s, 8)
			ipc.sleep(20)
			com.write(dev, 'NAVs' .. buffer_x, 8)
			switch ("NAV1 Swap", RADIOS, "RADIOS")
		else
		   -- NAV2
			Default_NAV_2_swap ()
			buffer_x = string.format("%04x", ipc.readUW(0x0352))
			buffer_s = string.format("%04x", ipc.readUW(0x3120))
			ipc.sleep(20)
			com.write(dev, 'NAVX' .. buffer_s, 8)
			ipc.sleep(20)
			com.write(dev, 'NAVS' .. buffer_x, 8)
			switch ("NAV2 Swap", RADIOS, "RADIOS")
		end
		DspRadioMed('<->')
		com.write(dev, 'RADMhz', 8)
	-- ADF
	elseif RADIOS_MODE == 3 then
		if RADIOS_SUBMODE == 1 then
			-- ADF1
			switch ("ADF1 Swap", RADIOS, "RADIOS")
		else
		   -- ADF2
			switch ("ADF2 Swap", RADIOS, "RADIOS")
		end
		DspRadioMed('<->')
	-- DME
	elseif RADIOS_MODE == 4 then  -- do nothing
	-- TRN
	elseif RADIOS_MODE == 5 then
		Default_XPND_set (RADIOS_XPND_CODE)
		switch ("XPND Swap", RADIOS, "RADIOS")
--]]
	end
end




-- ###################################################################
-- ###################################################################

-- ## Glareshield ###############

function GL_Spoilers_Flight ()
    ipc.writeLvar("GS_SPOILERS_SW", 0)
    DspShow ("Splr", "flgt")
end

function GL_Spoilers_Taxi ()
    ipc.writeLvar("GS_SPOILERS_SW", 1)
    DspShow ("Splr", "taxi")
end

function GL_Spoilers_toggle ()
	if _tl("GS_SPOILERS_SW", 1) then
      GL_Spoilers_Flight ()
	else
      GL_Spoilers_Taxi ()
	end
end

function GL_STICKPUSHER_SHUTOFF_off ()
    MJCD8_Write(1, 41069)
    --ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    --ipc.writeLvar("MJC_VAR_WRITE_CODE", 41069)

    DspShow ("Stck", "off")
end

function GL_STICKPUSHER_SHUTOFF_on ()
    MJCD8_Write(0, 41069)
    --ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    --ipc.writeLvar("MJC_VAR_WRITE_CODE", 41069)

    DspShow ("Stck", "on")
end

function GL_STICKPUSHER_SHUTOFF_toggle ()
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 41069)
    ipc.sleep(10)
    if _tl("MJC_VAR_WRITE_VALUE", 1) then
      GL_STICKPUSHER_SHUTOFF_on ()
	else
      GL_STICKPUSHER_SHUTOFF_off ()
	end
end

--

function GL_ELEVTRIM_SHUTOFF_off ()
    MJCD8_Write(1, 151309)
    DspShow ("Elev", "off")
end

function GL_ELEVTRIM_SHUTOFF_on ()
    MJCD8_Write(0, 151309)
    DspShow ("Elev", "on")
end

function GL_ELEVTRIM_SHUTOFF_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 151309)
    ipc.sleep(10)
    if _tl("MJC_VAR_READ_VALUE", 1) then
      GL_ELEVTRIM_SHUTOFF_on ()
	else
      GL_ELEVTRIM_SHUTOFF_off ()
	end
end

---

function GL_EGPWS_TEST_toggle ()
    MJCD8_Write(1, 54575)
    MJCD8_Write(0, 54575)
    DspShow ("GPWS", "test")
end

---

function GL_EGPWS_GSWarn_toggle ()
    MJCD8_Write(1, 71459)
    MJCD8_Write(0, 71459)
    DspShow ("GPWS", "GS")
end

--

function GL_TERRAIN_INHIBIT_off ()
    MJCD8_Write(1, 56093)
    MJCD8_Write(0, 56093)
    DspShow ("Terr", "off")
end

function GL_TERRAIN_INHIBIT_on ()
    MJCD8_Write(0, 56093)
    MJCD8_Write(1, 56093)
    DspShow ("Terr", "on")
end

function GL_TERRAIN_INHIBIT_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 56093)
    ipc.sleep(10)
    if _tl("MJC_VAR_READ_VALUE", 1) then
      GL_TERRAIN_INHIBIT_on ()
	else
      GL_TERRAIN_INHIBIT_off ()
	end
end

---

function GL_Warning_press ()
    MJCD8_Write(1, 156554)
    DspShow ("Warn", "prss")
end

function GL_Caution_press ()
    MJCD8_Write(1, 156520)
    DspShow ("Caut", "prss")
end

function GL_WarningAndCaution_press ()
    GL_Caution_press ()
    ipc.sleep(10)
    GL_Warning_press ()
end

function GL_AntiSkid_on ()
    MJCD8_Write(1, 96582)
    DspShow ("ASkd", "on")
end

function GL_AntiSkid_off ()
    MJCD8_Write(0, 96582)
    DspShow ("ASkd", "off")
end

function GL_AntiSkid_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 96582)
    ipc.sleep(30)
    if _tl("MJC_VAR_READ_VALUE", 0) then
       GL_AntiSkid_on ()
	else
       GL_AntiSkid_off ()
	end
end


-- ## Glareshield AP ###############

function MJCD8_HDG_BUG_inc ()
    HDG_plus (a, b, c)
    MJCD8_HDG_Show ()
end

function MJCD8_HDG_BUG_incfast ()
    i = 0
    for i = 1,10,1 do
        HDG_plus (a, b, c)
        MJCD8_HDG_Show ()
    end
end

function MJCD8_HDG_BUG_dec ()
    HDG_minus (a, b, c)
    MJCD8_HDG_Show ()
end

function MJCD8_HDG_BUG_decfast ()
    i = 0
    for i = 1,10,1 do
        HDG_minus (a, b, c)
        MJCD8_HDG_Show ()
    end
end

--

function MJCD8_CRS1_BUG_inc ()
    MJCD8_Write(1, 33284)
    MJCD8_CRS1_Show ()
end

function MJCD8_CRS1_BUG_incfast ()
    i = 0
    for i = 1,10,1 do
        MJCD8_Write(1, 33284)
        MJCD8_CRS1_Show ()
    end
    MJCD8_CRS1_Show ()
end

function MJCD8_CRS1_BUG_dec ()
    MJCD8_Write(-1, 33284)
    MJCD8_CRS1_Show ()
end

function MJCD8_CRS1_BUG_decfast ()
    i = 0
    for i = 1,10,1 do
        MJCD8_Write(-1, 33284)
        MJCD8_CRS1_Show ()
    end
    MJCD8_CRS1_Show ()
end

--

function MJCD8_CRS2_BUG_inc ()
    MJCD8_Write(1, 33380)
    MJCD8_CRS2_Show ()
end

function MJCD8_CRS2_BUG_incfast ()
    MJCD8_Write(10, 33380)
    MJCD8_CRS2_Show ()
end

function MJCD8_CRS2_BUG_dec ()
    MJCD8_Write(-1, 33380)
    MJCD8_CRS2_Show ()
end

function MJCD8_CRS2_BUG_decfast ()
    MJCD8_Write(-10, 33380)
    MJCD8_CRS2_Show ()
end

--

function MJCD8_ALT_BUG_inc ()
    ALT_plus (a, b, c)
    MJCD8_ALT_Show ()
end

function MJCD8_ALT_BUG_incfast ()
    i = 0
    for i = 1,10,1 do
        ALT_plus (a, b, c)
        MJCD8_ALT_Show ()
    end
end

function MJCD8_ALT_BUG_dec ()
    ALT_minus (a, b, c)
    MJCD8_ALT_Show ()
end

function MJCD8_ALT_BUG_decfast ()
    i = 0
    for i = 1,10,1 do
        ALT_minus (a, b, c)
        MJCD8_ALT_Show ()
    end
end

--

function AP_PFD1_SOURCE_show ()
    ipc.sleep(100)
    Pfd1NavVar = ipc.readLvar("GS_NAV1_KNOB_ANGLE")
    if Pfd1NavVar == 7 then Pfd1NavTxt = "FMS1" elseif
        Pfd1NavVar == 14 then Pfd1NavTxt = "NAV1" elseif
        Pfd1NavVar == 21 then Pfd1NavTxt = "NAV2" elseif
        Pfd1NavVar == 28 then Pfd1NavTxt = "FMS2"
    end
    DspShow ("PFD1", Pfd1NavTxt)
end

function AP_PFD1_SOURCE_inc ()
    MJCD8_Write(1, 51406)
    AP_PFD1_SOURCE_show ()
end

function AP_PFD1_SOURCE_dec ()
    MJCD8_Write(-1, 51406)
    AP_PFD1_SOURCE_show ()
end

function AP_IAS_press ()
    MJCD8_Write(1, 33470)
    DspShow ("IAS", "")
end

function AP_VS_press ()
    MJCD8_Write(2, 33470)
    DspShow ("VS", "")
end

function AP_VNAV_press ()
    MJCD8_Write(3, 33470)
    DspShow ("VNAV", "")
end

function AP_ALT_press ()
    MJCD8_Write(4, 33470)
    DspShow ("ALT", "hold")
end

function AP_ALTsel_press ()
    MJCD8_Write(5, 33470)
    DspShow ("ALT", "sel")
end

function AP_VS_PITCH_DN ()
    MJCD8_Write(1, 46987)
    DspShow ("VS", "down")
    MJCD8_VS_Show ()
    MJCD8_SPD_Show ()
end

function AP_VS_PITCH_DNfast ()
    i= 0
    for i = 1,5,1 do
        MJCD8_Write(1, 46987)
    end
    DspShow ("VS", "down")
    MJCD8_VS_Show ()
    MJCD8_SPD_Show ()
end

function AP_VS_PITCH_UP ()
    MJCD8_Write(-1, 46987)
    DspShow ("VS", "up")
    MJCD8_VS_Show ()
    MJCD8_SPD_Show ()
end

function AP_VS_PITCH_UPfast ()
    i= 0
    for i = 1,5,1 do
        MJCD8_Write(-1, 46987)
    end
    DspShow ("VS", "up")
    MJCD8_VS_Show ()
    MJCD8_SPD_Show ()
end

function AP_HDG_press ()
    MJCD8_Write(6, 33470)
    DspShow ("HDG", "")
end

function AP_NAV_press ()
    MJCD8_Write(7, 33470)
    DspShow ("NAV", "")
end

function AP_APPR_press ()
    MJCD8_Write(8, 33470)
    DspShow ("APPR", "")
end

function AP_BC_press ()
    MJCD8_Write(9, 33470)
    DspShow ("BC", "")
end

function AP_STBY_press ()
    MJCD8_Write(10, 33470)
    DspShow ("STBY", "")
end

function AP_AP_press ()
    MJCD8_Write(11, 33470)
    DspShow ("AP", "mstr")
end

function AP_YD_press ()
    MJCD8_Write(12, 33470)
    DspShow ("YD", "")
end

function AP_HSISEL_press ()
    MJCD8_Write(13, 33470)
    DspShow ("HSI", "sel")
end

function AP_AP_disengage ()
    ipc.writeLvar("L:Q400_AP_DISENGAGE_KNOB", 1)
    DspShow ("AP", "soft")
end

-- ## OHD DC Control ###############
function DC_StbyBatt_On ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_STB_SW", 1)
    DspShow ("Stby", "on")
end

function DC_StbyBatt_Off ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_STB_SW", 0)
    DspShow ("Stby", "off")
end

function DC_StbyBatt_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_STB_SW", 0) then
       DC_StbyBatt_On ()
	else
       DC_StbyBatt_Off ()
	end
end

function DC_AUXBatt_On ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_AUX_SW", 1)
    DspShow ("Aux", "on")
end

function DC_AUXBatt_Off ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_AUX_SW", 0)
    DspShow ("Aux", "off")
end

function DC_AUXBatt_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_AUX_SW", 0) then
      DC_AUXBatt_On ()
	else
      DC_AUXBatt_Off ()
	end
end

function DC_MainBatt_On ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_MAIN_SW", 1)
    DspShow ("Main", "on")
end

function DC_MainBatt_Off ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_MAIN_SW", 0)
    DspShow ("Main", "off")
end

function DC_MainBatt_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_MAIN_SW", 0) then
      DC_MainBatt_On ()
	else
      DC_MainBatt_Off ()
	end
end

function DC_BattMaster_On ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_MASTER_SW", 1)
    DspShow ("Batt", "on")
end

function DC_BattMaster_Off ()
    ipc.writeLvar("L:OHD_DC_CNTRL_PNL_MASTER_SW", 0)
    DspShow ("Batt", "off")
end

function DC_BattMaster_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_MASTER_SW", 0) then
        DC_BattMaster_On ()
	else
        DC_BattMaster_Off ()
	end
end

function DC_All_Batteries_On ()
    DC_BattMaster_On ()
    _sleep(100,250)
    DC_MainBatt_On ()
    _sleep(100,250)
    DC_AUXBatt_On ()
    _sleep(100,250)
    DC_StbyBatt_On ()
end

function DC_All_Batteries_Off ()
    DC_StbyBatt_Off ()
    _sleep(100,250)
    DC_AUXBatt_Off ()
    _sleep(100,250)
    DC_MainBatt_Off ()
    _sleep(100,250)
    DC_BattMaster_Off ()
end

function DC_All_Batteries_Toggle ()
	if _tl("OHD_DC_CNTRL_PNL_MASTER_SW", 0) then
        DC_All_Batteries_On ()
	else
        DC_All_Batteries_Off ()
	end
end

----------------

function DC_Gen1_On ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_GEN1_SW", 1)
    DspShow ("Gen1", "on")
end

function DC_Gen1_Off ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_GEN1_SW", 0)
    DspShow ("Gen1", "off")
end

function DC_Gen1_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_GEN1_SW", 0) then
        DC_Gen1_On ()
	else
        DC_Gen1_Off ()
	end
end

function DC_Gen2_On ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_GEN2_SW", 1)
    DspShow ("Gen2", "on")
end

function DC_Gen2_Off ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_GEN2_SW", 0)
    DspShow ("Gen2", "off")
end

function DC_Gen2_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_GEN2_SW", 0) then
        DC_Gen2_On ()
	else
        DC_Gen2_Off ()
	end
end

---

function DC_AllGen_On ()
    DC_Gen1_On ()
    _sleep(100,200)
    DC_Gen2_On ()
end

function DC_AllGen_Off ()
    DC_Gen2_Off ()
    _sleep(100,200)
    DC_Gen1_Off ()
end

function DC_AllGen_toggle ()
    DC_Gen1_toggle ()
    _sleep(100,200)
    DC_Gen2_toggle ()
end

---

function DC_MainBusTIE_On ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_TIE_SW", 1)
    DspShow ("Main", "tie")
end

function DC_MainBusTIE_Off ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_TIE_SW", 0)
    DspShow ("Main", "off")
end

function DC_MainBusTIE_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_TIE_SW", 0) then
       DC_MainBusTIE_On ()
	else
        DC_MainBusTIE_Off ()
	end
end

---

function DC_BusFault_reset ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_RESET_SW", 1)
    _sleep(100,200)
    ipc.writeLvar("OHD_DC_CNTRL_PNL_RESET_SW", 0)
    DspShow ("Bus", "rset")
end

---

function DC_ExtPower_On ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_EXTPWR_SW", 1)
    DspShow ("ExtP", "on")
end

function DC_ExtPower_Off ()
    ipc.writeLvar("OHD_DC_CNTRL_PNL_EXTPWR_SW", 0)
    DspShow ("ExtP", "off")
end

function DC_ExtPower_toggle ()
	if _tl("OHD_DC_CNTRL_PNL_EXTPWR_SW", 0) then
        DC_ExtPower_On ()
	else
        DC_ExtPower_Off ()
	end
end

-- ## OHD ICE Protection ###############

function ICE_AirframeMode_show ()
    ipc.sleep(50)
    ICEModeVar = ipc.readLvar("OHD_AICE_AFRAME_MODE_KNOB_ANGLE")
    if ICEModeVar == -1 then ICEModeTxt = "man" elseif
    ICEModeVar == 0 then ICEModeTxt = "off" elseif
    ICEModeVar == 1 then ICEModeTxt = "slow" elseif
    ICEModeVar == 2 then ICEModeTxt = "fast" end
    DspShow ("Mode", ICEModeTxt)
end

function ICE_AirframeMode_Manual ()
    MJCD8_Write(3, 93613)
    ICE_AirframeMode_show ()
end

function ICE_AirframeMode_Off ()
    MJCD8_Write(0, 93613)
    ICE_AirframeMode_show ()
end

function ICE_AirframeMode_Slow ()
    MJCD8_Write(1, 93613)
    ICE_AirframeMode_show ()
end

function ICE_AirframeMode_Fast ()
    MJCD8_Write(2, 93613)
    ICE_AirframeMode_show ()
end

function ICE_AirframeMode_inc ()
    ipc.sleep(50)
    ICEModeVar = ipc.readLvar("OHD_AICE_AFRAME_MODE_KNOB_ANGLE")
    if ICEModeVar == 0 then ICE_AirframeMode_Slow ()
    elseif ICEModeVar == 1 then ICE_AirframeMode_Fast ()
    elseif ICEModeVar == -1 then ICE_AirframeMode_Off ()
    end
    ICE_AirframeMode_show ()
end

function ICE_AirframeMode_dec ()
    ipc.sleep(50)
    ICEModeVar = ipc.readLvar("OHD_AICE_AFRAME_MODE_KNOB_ANGLE")
    if ICEModeVar == 2 then ICE_AirframeMode_Slow ()
    elseif ICEModeVar == 1 then ICE_AirframeMode_Off ()
    elseif ICEModeVar == 0 then ICE_AirframeMode_Manual ()
    end
    ICE_AirframeMode_show ()
end

------

function ICE_AirframeManual_show ()
    IceManVar = MJCD8_Read(103016) - 1
    if IceManVar == 0 then ICEModeTxt = "off"
    elseif IceManVar == -1 then ICEModeTxt = " 7" else
    ICEModeTxt = " " .. IceManVar
    end
    DspShow ("Man", ICEModeTxt)
end

function ICE_AirframeManual_inc ()
    IceManVar = MJCD8_Read(103016)
    if IceManVar < 7 then
    IceManVar = IceManVar + 1
    else IceManVar = 0
    end
    MJCD8_Write(IceManVar, 103016)
    ICE_AirframeManual_show ()
end

function ICE_AirframeManual_dec ()
    IceManVar = MJCD8_Read(103016)

    if IceManVar > 0 then
    IceManVar = IceManVar - 1
    else IceManVar = 7
    end
    MJCD8_Write(IceManVar, 103016)
    ICE_AirframeManual_show ()
end

-------
function ICE_Props_show ()
    IcePropVar = MJCD8_Read(55267)
    if IcePropVar == 1 then
    IcePropTxt = "on"
    elseif IcePropVar == 0 then
    IcePropTxt = "off"
    elseif IcePropVar == 2 then
    IcePropTxt = "test"
    end
    DspShow ("Prop", IcePropTxt)
end

function ICE_Props_Test ()
    MJCD8_Write(2, 55267)
    ICE_Props_show ()
end

function ICE_Props_Off ()
    MJCD8_Write(0, 55267)
    ICE_Props_show ()
end

function ICE_Props_On ()
    MJCD8_Write(1, 55267)
    ICE_Props_show ()
end

function ICE_Props_inc ()
    IcePropVar = MJCD8_Read(55267)
    if IcePropVar == 0 then
        ICE_Props_On ()
    elseif IcePropVar == 2 then
        ICE_Props_Off ()
    end
    ICE_Props_show ()
end

function ICE_Props_dec ()
    IcePropVar = MJCD8_Read(55267)
    if IcePropVar == 0 then
        ICE_Props_Test ()
    elseif IcePropVar == 1 then
        ICE_Props_Off ()
    end
    ICE_Props_show ()
end

-------

function ICE_EngIntake_L_open ()
    MJCD8_Write(1, 70232)
    DspShow ("IntL", "open")
end

function ICE_EngIntake_L_close ()
    MJCD8_Write(0, 70232)
    DspShow ("IntL", "clse")
end

function ICE_EngIntake_L_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 70232)
    ipc.sleep(10)
	if _tl("MJC_VAR_READ_VALUE", 0) then
       ICE_EngIntake_L_open ()
	else
       ICE_EngIntake_L_close ()
	end
end

-------

function ICE_EngIntake_R_open ()
    MJCD8_Write(1, 70269)
    DspShow ("IntR", "open")
end

function ICE_EngIntake_R_close ()
    MJCD8_Write(0, 70269)
    DspShow ("IntR", "clse")
end

function ICE_EngIntake_R_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 70269)
    ipc.sleep(10)
	if _tl("MJC_VAR_READ_VALUE", 0) then
       ICE_EngIntake_R_open ()
	else
       ICE_EngIntake_R_close ()
	end
end

function ICE_EngIntake_both_open ()
    ICE_EngIntake_L_open ()
    ICE_EngIntake_R_open ()
end

function ICE_EngIntake_both_close ()
    ICE_EngIntake_L_close ()
    ICE_EngIntake_R_close ()
end

-------

function ICE_RefSpeeds_incr ()
    ipc.writeLvar("L:OHD_AICE_ENG_INTAKE_REF_SW", 1)
    DspShow ("RefS", "incr")
end

function ICE_RefSpeeds_off ()
    ipc.writeLvar("L:OHD_AICE_ENG_INTAKE_REF_SW", 0)
    DspShow ("RefS", "off")
end

function ICE_RefSpeeds_toggle ()
	if _tl("OHD_AICE_ENG_INTAKE_REF_SW", 0) then
        ICE_RefSpeeds_incr ()
	else
        ICE_RefSpeeds_off ()
	end
end

-------

function ICE_BootAir_iso ()
    ipc.writeLvar("L:OHD_AICE_BOOT_AIR_SW", 1)
    DspShow ("Boot", "iso")
end

function ICE_BootAir_norm ()
    ipc.writeLvar("L:OHD_AICE_BOOT_AIR_SW", 0)
    DspShow ("Boot", "norm")
end

function ICE_BootAir_toggle ()
	if _tl("OHD_AICE_BOOT_AIR_SW", 0) then
        ICE_BootAir_iso ()
	else
        ICE_BootAir_norm ()
	end
end

------------

function ICE_PitotStby_On ()
    ipc.writeLvar("L:OHD_AICE_PITOT_STBY_SW", 1)
    DspShow ("PitS", "on")
end

function ICE_PitotStby_Off ()
    ipc.writeLvar("L:OHD_AICE_PITOT_STBY_SW", 0)
    DspShow ("PitS", "off")
end

function ICE_PitotStby_toggle ()
	if _tl("OHD_AICE_PITOT_STBY_SW", 0) then
       ICE_PitotStby_On ()
	else
       ICE_PitotStby_Off ()
	end
end

function ICE_Pitot_1_On ()
    ipc.writeLvar("L:OHD_AICE_PITOT_1_SW", 1)
    DspShow ("Pit1", "on")
end

function ICE_Pitot_1_Off ()
    ipc.writeLvar("L:OHD_AICE_PITOT_1_SW", 0)
    DspShow ("Pit1", "off")
end

function ICE_Pitot_1_toggle ()
	if _tl("OHD_AICE_PITOT_1_SW", 0) then
       ICE_Pitot_1_On ()
	else
       ICE_Pitot_1_Off ()
	end
end

function ICE_Pitot_2_On ()
    ipc.writeLvar("L:OHD_AICE_PITOT_2_SW", 1)
    DspShow ("Pit2", "on")
end

function ICE_Pitot_2_Off ()
    ipc.writeLvar("L:OHD_AICE_PITOT_2_SW", 0)
    DspShow ("Pit2", "off")
end

function ICE_Pitot_2_toggle ()
	if _tl("OHD_AICE_PITOT_2_SW", 0) then
       ICE_Pitot_2_On ()
	else
       ICE_Pitot_2_Off ()
	end
end

function ICE_Pitot_all_on ()
    ICE_PitotStby_On ()
    _sleep(150, 250)
    ICE_Pitot_1_On ()
    _sleep(150, 250)
    ICE_Pitot_2_On ()
end

function ICE_Pitot_all_off ()
    ICE_Pitot_2_Off ()
    _sleep(150, 250)
    ICE_Pitot_1_Off ()
    _sleep(150, 250)
    ICE_PitotStby_Off ()
end

function ICE_Pitot_all_toggle ()
    ICE_PitotStby_toggle ()
    _sleep(150, 250)
    ICE_Pitot_1_toggle ()
    _sleep(150, 250)
    ICE_Pitot_2_toggle ()
end

-- ## OHD Windshield ###############

function WS_Heat_Show ()
    ipc.sleep(30)
    WSHeatVar = ipc.readLvar("OHD_WSHIELD_HEAT_KNOB_ANGLE")
    if WSHeatVar ==  0 then WSHeatTxt = "off" elseif
    WSHeatVar ==  1 then WSHeatTxt = "warm" elseif
    WSHeatVar ==  2 then WSHeatTxt = "norm" end
    DspShow ("Heat", WSHeatTxt)
end

function WS_Heat_inc ()
    ipc.sleep(30)
    WSHeatVar = ipc.readLvar("OHD_WSHIELD_HEAT_KNOB_ANGLE")
    if WSHeatVar ==  0 then WS_Heat_WarmUp () elseif
    WSHeatVar ==  1 then WS_Heat_Norm () end
    WS_Heat_Show ()
end

function WS_Heat_dec ()
    ipc.sleep(30)
    WSHeatVar = ipc.readLvar("OHD_WSHIELD_HEAT_KNOB_ANGLE")
    if WSHeatVar ==  2 then WS_Heat_WarmUp () elseif
    WSHeatVar ==  1 then WS_Heat_Off () end
    WS_Heat_Show ()
end

function WS_Heat_Off ()
    MJCD8_Write(0, 72130)
    WS_Heat_Show ()
end

function WS_Heat_WarmUp ()
    MJCD8_Write(1, 72130)
    WS_Heat_Show ()
end

function WS_Heat_Norm ()
    MJCD8_Write(2, 72130)
    WS_Heat_Show ()
end

function WS_Wiper_Show ()
    ipc.sleep(30)
    WSWiperVar = ipc.readLvar("OHD_WSHIELD_WIPER_KNOB_ANGLE")
    if WSWiperVar ==  0 then WSWiperTxt = "park" elseif
    WSWiperVar ==  1 then WSWiperTxt = "off" elseif
    WSWiperVar ==  2 then WSWiperTxt = "low" elseif
    WSWiperVar ==  3 then WSWiperTxt = "high" end
    DspShow ("Wipr", WSWiperTxt)
end

function WS_Wiper_inc ()
    ipc.sleep(30)
    WSWiperVar = ipc.readLvar("OHD_WSHIELD_WIPER_KNOB_ANGLE")
    if WSWiperVar ==  0 then WS_Wiper_Off () elseif
    WSWiperVar ==  1 then  WS_Wiper_Low () elseif
    WSWiperVar ==  2 then  WS_Wiper_High () end
    WS_Wiper_Show ()
end

function WS_Wiper_dec ()
    ipc.sleep(30)
    WSWiperVar = ipc.readLvar("OHD_WSHIELD_WIPER_KNOB_ANGLE")
    if WSWiperVar ==  1 then WS_Wiper_Park () elseif
    WSWiperVar ==  2 then  WS_Wiper_Off () elseif
    WSWiperVar ==  3 then  WS_Wiper_Low () end
    WS_Wiper_Show ()
end

function WS_Wiper_Park ()
    MJCD8_Write(0, 38451)
    WS_Wiper_Show ()
end

function WS_Wiper_Off ()
    MJCD8_Write(1, 38451)
    WS_Wiper_Show ()
end

function WS_Wiper_Low ()
    MJCD8_Write(2, 38451)
    WS_Wiper_Show ()
end

function WS_Wiper_High ()
    MJCD8_Write(3, 38451)
    WS_Wiper_Show ()
end

-------------

function WS_PilotWindowHeat_On ()
    ipc.writeLvar("OHD_WDO_HEAT_SW", 1)
    DspShow ("Heat", "on")
end

function WS_PilotWindowHeat_Off ()
    ipc.writeLvar("OHD_WDO_HEAT_SW", 0)
    DspShow ("Heat", "off")
end

function WS_PilotWindowHeat_toggle ()
	if _tl("OHD_WDO_HEAT_SW", 0) then
       WS_PilotWindowHeat_On ()
	else
       WS_PilotWindowHeat_Off ()
	end
end


-- ## OHD Exterior Lights ###############

function Lights_Approach_On ()
    ipc.writeLvar("OHD_EXT_LIGHTS_L_APPR_SW", 1)
    DspShow ("AppL", "on")
end

function Lights_Approach_Off ()
    ipc.writeLvar("OHD_EXT_LIGHTS_L_APPR_SW", 0)
    DspShow ("AppL", "off")
end

function Lights_Approach_Toggle ()
	if _tl("OHD_EXT_LIGHTS_L_APPR_SW", 0) then
      Lights_Approach_On ()
	else
      Lights_Approach_Off ()
	end
end

---

function Lights_Flare_On ()
    ipc.writeLvar("OHD_EXT_LIGHTS_L_FLARE_SW", 1)
    DspShow ("Flre", "on")
end

function Lights_Flare_Off ()
    ipc.writeLvar("OHD_EXT_LIGHTS_L_FLARE_SW", 0)
    DspShow ("Flre", "off")
end

function Lights_Flare_Toggle ()
	if _tl("OHD_EXT_LIGHTS_L_FLARE_SW", 0) then
      Lights_Flare_On ()
	else
      Lights_Flare_Off ()
	end
end

---

function Light_LandingAll_On ()
    Lights_Approach_On ()
    _sleep(100,200)
    Lights_Flare_On ()
end

function Light_LandingAll_Off ()
    Lights_Approach_Off ()
    _sleep(100,200)
    Lights_Flare_Off ()
end

function Light_LandingAll_Toggle ()
    Lights_Approach_Toggle ()
    _sleep(100,200)
    Lights_Flare_Toggle ()
end

---

function Lights_Taxi_On ()
    ipc.writeLvar("OHD_EXT_LIGHTS_L_TAXI_SW", 1)
    DspShow ("Taxi", "on")
end

function Lights_Taxi_Off ()
    ipc.writeLvar("OHD_EXT_LIGHTS_L_TAXI_SW", 0)
    DspShow ("Taxi", "off")
end

function Lights_Taxi_Toggle ()
	if _tl("OHD_EXT_LIGHTS_L_TAXI_SW", 0) then
       Lights_Taxi_On ()
	else
       Lights_Taxi_Off ()
	end
end

---

function Lights_Wing_On ()
    ipc.writeLvar("OHD_EXT_LT_WING_SW", 1)
    DspShow ("Wing", "on")
end

function Lights_Wing_Off ()
    ipc.writeLvar("OHD_EXT_LT_WING_SW", 0)
    DspShow ("Wing", "off")
end

function Lights_Wing_Toggle ()
	if _tl("OHD_EXT_LT_WING_SW", 0) then
       Lights_Wing_On ()
	else
       Lights_Wing_Off ()
	end
end

function Lights_AntiCol_Red ()
    ipc.writeLvar("OHD_EXT_LT_ACOL_SW", 1)
    DspShow ("ACol", "red")
end

function Lights_AntiCol_Off ()
    ipc.writeLvar("OHD_EXT_LT_ACOL_SW", 0)
    DspShow ("ACol", "off")
end

function Lights_AntiCol_White ()
    ipc.writeLvar("OHD_EXT_LT_ACOL_SW", -1)
    DspShow ("ACol", "whte")
end

function Lights_AntiCol_Toggle ()
local AntiCol = ipc.readLvar("OHD_EXT_LT_ACOL_SW")
    if AntiCol == 0 then
        Lights_AntiCol_Red()
    elseif AntiCol == 1 then
        Lights_AntiCol_White()
    else
        Lights_AntiCol_Off()
    end
end

function Lights_POSN_On ()
    ipc.writeLvar("OHD_EXT_LT_POS_SW", 1)
    DspShow ("Pos", "on")
end

function Lights_POSN_Off ()
    ipc.writeLvar("OHD_EXT_LT_POS_SW", 0)
    DspShow ("Pos", "off")
end

function Lights_POSN_Toggle ()
	if _tl("OHD_EXT_LT_POS_SW", 0) then
      Lights_POSN_On ()
	else
      Lights_POSN_Off ()
	end
end

function Lights_LOGO_On ()
    ipc.writeLvar("OHD_EXT_LT_LOGO_SW", 1)
    DspShow ("Logo", "on")
end

function Lights_LOGO_Off ()
    ipc.writeLvar("OHD_EXT_LT_LOGO_SW", 0)
    DspShow ("Logo", "off")
end

function Lights_LOGO_Toggle ()
	if _tl("OHD_EXT_LT_LOGO_SW", 0) then
      Lights_LOGO_On ()
	else
      Lights_LOGO_Off ()
	end
end

-- ## OHD PANEL Lighting ###############

--- Value for all OHD lights increases/decreases
OhdLightDelta = 3000          -- increases/decreases
OhdLightDeltaFast = 10000     -- increases/decreases fast
OhdMiddle = 32767             -- 32767 is 50%, 65535 is 100%
-------------------------------------------------
-------------------------------------------------
function OHD_PanelL_OhdCons_show ()
    OhdConsL = round2(MJCD8_Read(76234)/655.35)
    DspShow ("CnsL", OhdConsL.."%")
end

function OHD_PanelL_OhdCons_inc ()
    OhdConsLVar = MJCD8_Read(76234)

    if OhdConsLVar < 60000 then
    OhdConsLVar = OhdConsLVar + OhdLightDelta
    else
    OhdConsLVar = 65535
    end
    MJCD8_Write(OhdConsLVar, 76234)
    OHD_PanelL_OhdCons_show ()
end

function OHD_PanelL_OhdCons_incfast ()
    OhdConsLVar = MJCD8_Read(76234)

    if OhdConsLVar < 55000 then
    OhdConsLVar = OhdConsLVar + OhdLightDeltaFast
    else
    OhdConsLVar = 65535
    end
    MJCD8_Write(OhdConsLVar, 76234)
    OHD_PanelL_OhdCons_show ()
end

function OHD_PanelL_OhdCons_dec ()
    OhdConsLVar = MJCD8_Read(76234)

    if OhdConsLVar > 5000 then
    OhdConsLVar = OhdConsLVar - OhdLightDelta
    else
    OhdConsLVar = 0
    end
    MJCD8_Write(OhdConsLVar, 76234)
    OHD_PanelL_OhdCons_show ()
end

function OHD_PanelL_OhdCons_decfast ()
    OhdConsLVar = MJCD8_Read(76234)

    if OhdConsLVar > 10500 then
    OhdConsLVar = OhdConsLVar - OhdLightDeltaFast
    else
    OhdConsLVar = 0
    end
    MJCD8_Write(OhdConsLVar, 76234)
    OHD_PanelL_OhdCons_show ()
end

function OHD_PanelL_OhdCons_0 ()
    MJCD8_Write(0, 76234)
    OHD_PanelL_OhdCons_show ()
end

function OHD_PanelL_OhdCons_50 ()
    MJCD8_Write(OhdMiddle, 76234)
    OHD_PanelL_OhdCons_show ()
end

function OHD_PanelL_OhdCons_100 ()
   MJCD8_Write(65535, 76234)
    OHD_PanelL_OhdCons_show ()
end

----------------------------
function OHD_PanelL_Glare_show ()
    OhdGlrL = round2(MJCD8_Read(106675)/655.35)
    DspShow ("GlrL", OhdGlrL.."%")
end

function OHD_PanelL_Glare_inc ()
    OhdGlrLVar = MJCD8_Read(106675)

    if OhdGlrLVar < 60000 then
    OhdGlrLVar = OhdGlrLVar + OhdLightDelta
    else
    OhdGlrLVar = 65535
    end

    MJCD8_Write(OhdGlrLVar, 106675)
    OHD_PanelL_Glare_show ()

end

function OHD_PanelL_Glare_incfast ()
    OhdGlrLVar = MJCD8_Read(106675)

    if OhdGlrLVar < 55000 then
    OhdGlrLVar = OhdGlrLVar + OhdLightDeltaFast
    else
    OhdGlrLVar = 65535
    end
    MJCD8_Write(OhdGlrLVar, 106675)
    OHD_PanelL_Glare_show ()
end

function OHD_PanelL_Glare_dec ()
    OhdGlrLVar = MJCD8_Read(106675)

    if OhdGlrLVar > 5000 then
    OhdGlrLVar = OhdGlrLVar - OhdLightDelta
    else
    OhdGlrLVar = 0
    end
    MJCD8_Write(OhdGlrLVar, 106675)
    OHD_PanelL_Glare_show ()
end

function OHD_PanelL_Glare_decfast ()
    OhdGlrLVar = MJCD8_Read(106675)

    if OhdGlrLVar > 10500 then
    OhdGlrLVar = OhdGlrLVar - OhdLightDeltaFast
    else
    OhdGlrLVar = 0
    end
    MJCD8_Write(OhdGlrLVar, 106675)
    OHD_PanelL_Glare_show ()
end

function OHD_PanelL_Glare_0 ()
    MJCD8_Write(0, 106675)
    OHD_PanelL_Glare_show ()
end

function OHD_PanelL_Glare_50 ()
    MJCD8_Write(OhdMiddle, 106675)
    OHD_PanelL_Glare_show ()
end

function OHD_PanelL_Glare_100 ()
    MJCD8_Write(65535, 106675)
    OHD_PanelL_Glare_show ()
end

----------FWD-------------------------------

function OHD_PanelL_Ctr_Fwd_show ()
    OhdFwdL = round2(MJCD8_Read(102227)/655.35)
    DspShow ("FwdL", OhdFwdL.."%")
end

function OHD_PanelL_Ctr_Fwd_inc ()
    OhdFwdLVar = MJCD8_Read(102227)

    if OhdFwdLVar < 60000 then
    OhdFwdLVar = OhdFwdLVar + OhdLightDelta
    else
    OhdFwdLVar = 65535
    end
    MJCD8_Write(OhdFwdLVar, 102227)
    OHD_PanelL_Ctr_Fwd_show ()

end

function OHD_PanelL_Ctr_Fwd_incfast ()
    OhdFwdLVar = MJCD8_Read(102227)

    if OhdFwdLVar < 55000 then
    OhdFwdLVar = OhdFwdLVar + OhdLightDeltaFast
    else
    OhdFwdLVar = 65535
    end
    MJCD8_Write(OhdFwdLVar, 102227)
    OHD_PanelL_Ctr_Fwd_show ()
end

function OHD_PanelL_Ctr_Fwd_dec ()
    OhdFwdLVar = MJCD8_Read(102227)

    if OhdFwdLVar > 5000 then
    OhdFwdLVar = OhdFwdLVar - OhdLightDelta
    else
    OhdFwdLVar = 0
    end
    MJCD8_Write(OhdFwdLVar, 102227)
    OHD_PanelL_Ctr_Fwd_show ()
end

function OHD_PanelL_Ctr_Fwd_decfast ()
    OhdFwdLVar = MJCD8_Read(102227)

    if OhdFwdLVar > 10500 then
    OhdFwdLVar = OhdFwdLVar - OhdLightDeltaFast
    else
    OhdFwdLVar = 0
    end
    MJCD8_Write(OhdFwdLVar, 102227)
    OHD_PanelL_Ctr_Fwd_show ()
end

function OHD_PanelL_Ctr_Fwd_0 ()
    MJCD8_Write(0, 102227)
    OHD_PanelL_Ctr_Fwd_show ()
end

function OHD_PanelL_Ctr_Fwd_50 ()
    MJCD8_Write(OhdMiddle, 102227)
    OHD_PanelL_Ctr_Fwd_show ()
end

function OHD_PanelL_Ctr_Fwd_100 ()
    MJCD8_Write(65535, 102227)
    OHD_PanelL_Ctr_Fwd_show ()
end

----------AFT-------------------------------
function OHD_PanelL_Ctr_Aft_show ()
    OhdAftL = round2(MJCD8_Read(101990)/655.35)
    DspShow ("FwdL", OhdAftL.."%")
end

function OHD_PanelL_Ctr_Aft_inc ()
    OhdAftLVar = MJCD8_Read(101990)

    if OhdAftLVar < 60000 then
    OhdAftLVar = OhdAftLVar + OhdLightDelta
    else
    OhdAftLVar = 65535
    end
    MJCD8_Write(OhdAftLVar, 101990)
    OHD_PanelL_Ctr_Aft_show ()

end

function OHD_PanelL_Ctr_Aft_incfast ()
    OhdAftLVar = MJCD8_Read(101990)

    if OhdAftLVar < 55000 then
    OhdAftLVar = OhdAftLVar + OhdLightDeltaFast
    else
    OhdAftLVar = 65535
    end
    MJCD8_Write(OhdAftLVar, 101990)
    OHD_PanelL_Ctr_Aft_show ()
end

function OHD_PanelL_Ctr_Aft_dec ()
    OhdAftLVar = MJCD8_Read(101990)

    if OhdAftLVar > 5000 then
    OhdAftLVar = OhdAftLVar - OhdLightDelta
    else
    OhdAftLVar = 0
    end
    MJCD8_Write(OhdAftLVar, 101990)
    OHD_PanelL_Ctr_Aft_show ()
end

function OHD_PanelL_Ctr_Aft_decfast ()
    OhdAftLVar = MJCD8_Read(101990)

    if OhdAftLVar > 10500 then
    OhdAftLVar = OhdAftLVar - OhdLightDeltaFast
    else
    OhdAftLVar = 0
    end
    MJCD8_Write(OhdAftLVar, 101990)
    OHD_PanelL_Ctr_Aft_show ()
end

function OHD_PanelL_Ctr_Aft_0 ()
    MJCD8_Write(0, 101990)
    OHD_PanelL_Ctr_Aft_show ()
end

function OHD_PanelL_Ctr_Aft_50 ()
    MJCD8_Write(OhdMiddle, 101990)
    OHD_PanelL_Ctr_Aft_show ()
end

function OHD_PanelL_Ctr_Aft_100 ()
    MJCD8_Write(65535, 101990)
    OHD_PanelL_Ctr_Aft_show ()
end

--------------------------------
function OHD_PanelL_All_incfast ()
    OHD_PanelL_OhdCons_incfast ()
    OHD_PanelL_Glare_incfast ()
    OHD_PanelL_Ctr_Fwd_incfast ()
    OHD_PanelL_Ctr_Aft_incfast ()
    CaptSide_InstrLight_incfast ()
end

function OHD_PanelL_All_decfast ()
    OHD_PanelL_OhdCons_decfast ()
    OHD_PanelL_Glare_decfast ()
    OHD_PanelL_Ctr_Fwd_decfast ()
    OHD_PanelL_Ctr_Aft_decfast ()
    CaptSide_InstrLight_decfast ()
end

function OHD_PanelL_All_0 ()
    OHD_PanelL_OhdCons_0 ()
    OHD_PanelL_Glare_0 ()
    OHD_PanelL_Ctr_Fwd_0 ()
    OHD_PanelL_Ctr_Aft_0 ()
    CaptSide_InstrLight_0 ()
end

function OHD_PanelL_All_50 ()
    OHD_PanelL_OhdCons_50 ()
    OHD_PanelL_Glare_50 ()
    OHD_PanelL_Ctr_Fwd_50 ()
    OHD_PanelL_Ctr_Aft_50 ()
    CaptSide_InstrLight_50 ()
end

function OHD_PanelL_All_100 ()
    OHD_PanelL_OhdCons_100 ()
    OHD_PanelL_Glare_100 ()
    OHD_PanelL_Ctr_Fwd_100 ()
    OHD_PanelL_Ctr_Aft_100 ()
    CaptSide_InstrLight_100 ()
end

--------------------------------

function Panel_Light_Dome_On ()
    ipc.writeLvar("OHD_PNL_LIGHTS_DOME_SW", 1)
    DspShow ("Dome", "on")
end

function Panel_Light_Dome_Off ()
    ipc.writeLvar("OHD_PNL_LIGHTS_DOME_SW", 0)
    DspShow ("Dome", "off")
end

function Panel_Light_Dome_Toggle ()
	if _tl("OHD_PNL_LIGHTS_DOME_SW", 0) then
       Panel_Light_Dome_On ()
	else
       Panel_Light_Dome_Off ()
	end
end

function Panel_Light_StormDome_Storm ()
    ipc.writeLvar("OHD_PNL_LIGHTS_STORM_SW", 1)
    DspShow ("Strm", "strm")
end

function Panel_Light_StormDome_StormDome ()
    ipc.writeLvar("OHD_PNL_LIGHTS_STORM_SW", -1)
    DspShow ("Strm", "dome")
end

function Panel_Light_StormDome_Off ()
    ipc.writeLvar("OHD_PNL_LIGHTS_STORM_SW", 0)
    DspShow ("Strm", "off")
end

function Panel_Light_Storm_toggle ()
	if _tl("OHD_PNL_LIGHTS_STORM_SW", 0) then
       Panel_Light_StormDome_Storm ()
	else
       Panel_Light_StormDome_Off ()
	end
end

function Panel_Light_ALLStormDome_On ()
    Panel_Light_Dome_On ()
    _sleep(100,200)
    Panel_Light_StormDome_StormDome ()
end

function Panel_Light_ALLStormDome_Off ()
    Panel_Light_StormDome_Off ()
    _sleep(100,200)
    Panel_Light_Dome_Off ()
end


-- ## OHD APU Control ###############

function APU_PWR_on ()
    MJCD8_Write(1, 53623)
    DspShow ("APU", "pwr")
end

function APU_PWR_off ()
    MJCD8_Write(0, 53623)
    MJCD8_Write(0, 64765)
    DspShow ("APU", "pwr")
end

function APU_PWR_toggle ()
    if _tl("OHD_APU_PUSHBUTTONS", 0) then
      APU_PWR_on ()
	else
      APU_PWR_off ()
	end
end

function APU_START_on ()
    MJCD8_Write(1, 64765)
    DspShow ("APU", "start")
end

function APU_GEN_on ()
    MJCD8_Write(1, 52698)
    DspShow ("APU", "Gen")
end

function APU_GEN_off ()
    MJCD8_Write(0, 52698)
    DspShow ("APU", "Gen")
end

function APU_GEN_toggle ()
    if _tl("OHD_APU_PUSHBUTTONS", 0) then
      APU_GEN_on ()
	else
      APU_GEN_off ()
	end
end

function APU_BleedAir_on ()
    MJCD8_Write(1, 57932)
    DspShow ("APU", "bled")
end

function APU_BleedAir_off ()
    MJCD8_Write(0, 57932)
    DspShow ("APU", "bled")
end

function APU_BleedAir_toggle ()
    if _tl("OHD_APU_PUSHBUTTONS", 0) then
      APU_BleedAir_on ()
	else
      APU_BleedAir_off ()
	end
end

-- ## OHD Engine Start ###############

function Engine_Eng1_Off ()
   ipc.writeLvar("OHD_ENGSTART_IGN1_KNOB_SW", 0)
   DspShow ("IGN1", "off")
end

function Engine_Eng1_Norm ()
   ipc.writeLvar("OHD_ENGSTART_IGN1_KNOB_SW", 1)
   DspShow ("IGN1", "norm")
end

function Engine_Eng1_Toggle ()
	if _tl("OHD_ENGSTART_IGN1_KNOB_SW", 0) then
      Engine_Eng1_Norm ()
	else
      Engine_Eng1_Off ()
	end
end

function Engine_Eng2_Off ()
   ipc.writeLvar("OHD_ENGSTART_IGN2_KNOB_SW", 0)
   DspShow ("IGN2", "off")
end

function Engine_Eng2_Norm ()
   ipc.writeLvar("OHD_ENGSTART_IGN2_KNOB_SW", 1)
   DspShow ("IGN2", "norm")
end

function Engine_Eng2_Toggle ()
	if _tl("OHD_ENGSTART_IGN2_KNOB_SW", 0) then
      Engine_Eng2_Norm ()
	else
      Engine_Eng2_Off ()
	end
end

function Engine_Start_Press ()
    MJCD8_Write(1, 73865)
    DspShow ("ENG", "STRT")
end


function Engine_Select_Eng1 ()
   ipc.writeLvar("OHD_ENGSTART_SELECT_SW", -1)
   DspShow ("ENG1", "sel")
end

function Engine_Select_Neutral ()
   ipc.writeLvar("OHD_ENGSTART_SELECT_SW", 0)
   DspShow ("no", "sel")
end

function Engine_Select_Eng2 ()
   ipc.writeLvar("OHD_ENGSTART_SELECT_SW", 1)
   DspShow ("ENG2", "sel")
end

function Select_Eng1_and_start ()
   Engine_Select_Eng1 ()
   _sleep(200,400)
   Engine_Start_Press ()
end

function Select_Eng2_and_start ()
   Engine_Select_Eng2 ()
   _sleep(200,400)
   Engine_Start_Press ()
end

-- ## Landing Altitude ###############

--- Value for all OHD lights increases/decreases
LdgAltDelta = 1000          -- increases/decreases
LdgAltDeltaFast = 3000     -- increases/decreases fast

function LdgAlt_Show ()
    LdgAltVar = ipc.readLvar("OHD_PRESSPNL_LDGALT_IND_ANGLE")
    LdgAltVar = round((LdgAltVar)*70)-2000
    if LdgAltVar > 10000 then LdgAltVar = LdgAltVar*1.15 end
    DspShow ("LAlt", round(LdgAltVar))
end

--function LdgAlt_show ()
--    ipc.writeLvar("MJC_VAR_READ_CODE", 74053)
--    ipc.sleep(10)
--    LdgAlt = round2(ipc.readLvar("MJC_VAR_READ_VALUE")/655.35)
--    DspShow ("Alt", LdgAlt.."%")
--end

function LdgAlt_dec ()
    LdgAltVar = MJCD8_Read(74053)

    if LdgAltVar < 60000 then
    LdgAltVar = LdgAltVar + LdgAltDelta
    else
    LdgAltVar = 65535
    end
    MJCD8_Write(LdgAltVar, 74053)
    LdgAlt_Show ()

end

function LdgAlt_decfast ()
    LdgAltVar = MJCD8_Read(74053)

    if LdgAltVar < 55000 then
    LdgAltVar = LdgAltVar + LdgAltDeltaFast
    else
    LdgAltVar = 65535
    end
    MJCD8_Write(LdgAltVar, 74053)
    LdgAlt_Show ()
end

function LdgAlt_inc ()
    LdgAltVar = MJCD8_Read(74053)

    if LdgAltVar > 5000 then
    LdgAltVar = LdgAltVar - LdgAltDelta
    else
    LdgAltVar = 0
    end
    MJCD8_Write(LdgAltVar, 74053)
    LdgAlt_Show ()
end

function LdgAlt_incfast ()
    LdgAltVar = MJCD8_Read(74053)

    if LdgAltVar > 10500 then
    LdgAltVar = LdgAltVar - LdgAltDeltaFast
    else
    LdgAltVar = 0
    end
    MJCD8_Write(LdgAltVar, 74053)
    LdgAlt_Show ()
end


function CabAlt_Mode_dump ()
   ipc.writeLvar("OHD_CAB_ALT_MODE_SW", 2)
   DspShow ("Mode", "dump")
end

function CabAlt_Mode_man ()
   ipc.writeLvar("OHD_CAB_ALT_MODE_SW", 1)
   DspShow ("Mode", "man")
end

function CabAlt_Mode_auto ()
   ipc.writeLvar("OHD_CAB_ALT_MODE_SW", 0)
   DspShow ("Mode", "auto")
end

function CabAlt_Man_inc ()
   ipc.writeLvar("OHD_CAB_MAN_OFF_SW", 2)
   DspShow ("Man", "inc")
end

function CabAlt_Man_off ()
   ipc.writeLvar("OHD_CAB_MAN_OFF_SW", 1)
   DspShow ("Man", "off")
end

function CabAlt_Man_dec ()
   ipc.writeLvar("OHD_CAB_MAN_OFF_SW", 0)
   DspShow ("Man", "dec")
end

-- ## OHD AC Control ###############
function AC_ExtPower_Off ()
    ipc.writeLvar("OHD_AC_CTRL_EXT_PWR_SW", 0)
    DspShow ("AExt", "off")
end

function AC_ExtPower_On ()
    ipc.writeLvar("OHD_AC_CTRL_EXT_PWR_SW", 1)
    DspShow ("AExt", "on")
end

function AC_ExtPower_Toggle ()
	if _tl("OHD_AC_CTRL_EXT_PWR_SW", 0) then
        AC_ExtPower_On ()
	else
        AC_ExtPower_Off ()
	end
end

---------

function AC_Gen1_On ()
    ipc.writeLvar("OHD_AC_CTRL_GEN1_SW", 1)
    DspShow ("Gen1", "on")
end

function AC_Gen1_Off ()
    ipc.writeLvar("OHD_AC_CTRL_GEN1_SW", 0)
    DspShow ("Gen1", "off")
end

function AC_Gen1_Toggle ()
	if _tl("OHD_AC_CTRL_GEN1_SW", 0) then
      AC_Gen1_On ()
	else
      AC_Gen1_Off ()
	end
end

---------

function AC_Gen2_On ()
    ipc.writeLvar("OHD_AC_CTRL_GEN2_SW", 1)
    DspShow ("Gen2", "on")
end

function AC_Gen2_Off ()
    ipc.writeLvar("OHD_AC_CTRL_GEN2_SW", 0)
    DspShow ("Gen2", "off")
end

function AC_Gen2_Toggle ()
	if _tl("OHD_AC_CTRL_GEN2_SW", 0) then
       AC_Gen2_On ()
	else
       AC_Gen2_Off ()
	end
end

----

function AC_Gen_All_On ()
    AC_Gen1_On ()
    _sleep(150,250)
    AC_Gen2_On ()
end

function AC_Gen_All_Off ()
    AC_Gen1_Off ()
    _sleep(150,250)
    AC_Gen2_Off ()
end

function AC_Gen_All_Toggle ()
    AC_Gen1_Toggle ()
    _sleep(150,250)
    AC_Gen2_Toggle ()
end

-- ## OHD Air Condition ###############

function AirCon_Recirc_Off ()
    ipc.writeLvar("OHD_AIR_COND_RECIRC_SW", 0)
    DspShow ("Rcrc", "off")
end

function AirCon_Recirc_On ()
    ipc.writeLvar("OHD_AIR_COND_RECIRC_SW", 1)
    DspShow ("Rcrc", "on")
end

function AirCon_Recirc_toggle ()
	if _tl("OHD_AIR_COND_RECIRC_SW", 0) then
       AirCon_Recirc_On ()
	else
       AirCon_Recirc_Off ()
	end
end

function AirCon_Bleed1_Off ()
    ipc.writeLvar("OHD_AIR_COND_BLEED1_SW", 0)
    DspShow ("Bld1", "off")
end

function AirCon_Bleed1_On ()
    ipc.writeLvar("OHD_AIR_COND_BLEED1_SW", 1)
    DspShow ("Bld1", "on")
end

function AirCon_Bleed1_toggle ()
	if _tl("OHD_AIR_COND_BLEED1_SW", 0) then
       AirCon_Bleed1_On ()
	else
       AirCon_Bleed1_Off ()
	end
end

-----

function AirCon_Bleed2_Off ()
    ipc.writeLvar("OHD_AIR_COND_BLEED2_SW", 0)
    DspShow ("Bld2", "off")
end

function AirCon_Bleed2_On ()
    ipc.writeLvar("OHD_AIR_COND_BLEED2_SW", 1)
    DspShow ("Bld2", "on")
end

function AirCon_Bleed2_toggle ()
	if _tl("OHD_AIR_COND_BLEED2_SW", 0) then
       AirCon_Bleed2_On ()
	else
       AirCon_Bleed2_Off ()
	end
end

---

function AirCon_All_Bleed_On ()
      AirCon_Bleed1_On ()
      _sleep(150,250)
      AirCon_Bleed2_On ()
end

function AirCon_All_Bleed_Off ()
      AirCon_Bleed1_Off ()
      _sleep(150,250)
      AirCon_Bleed2_Off ()
end

function AirCon_All_Bleed_toggle ()
      AirCon_Bleed1_toggle ()
      _sleep(150,250)
      AirCon_Bleed2_toggle ()
end

-------------------------------

function AirCon_Bleed_Show ()
    ipc.sleep(30)
    ACBldVar = ipc.readLvar("OHD_AIR_COND_BLEED_KNOB")
    if ACBldVar == -1 then ACBldTxt = "min" elseif
    ACBldVar == 0 then ACBldTxt = "norm" elseif
    ACBldVar == 1 then ACBldTxt = "max" end
    DspShow ("ABld", ACBldTxt)
end

function AirCon_Bleed_inc ()
    ipc.sleep(30)
    ACBldVar = ipc.readLvar("OHD_AIR_COND_BLEED_KNOB")
    if ACBldVar == -1 then AirCon_Bleed_Norm () elseif
    ACBldVar == 0 then AirCon_Bleed_Max () end
    AirCon_Bleed_Show ()
end

function AirCon_Bleed_dec ()
    ipc.sleep(30)
    ACBldVar = ipc.readLvar("OHD_AIR_COND_BLEED_KNOB")
    if ACBldVar == 1 then AirCon_Bleed_Norm () elseif
    ACBldVar == 0 then AirCon_Bleed_Min () end
    AirCon_Bleed_Show ()
end

function AirCon_Bleed_Min ()
    MJCD8_Write(1, 41534)
    AirCon_Bleed_Show ()
end

function AirCon_Bleed_Norm ()
    MJCD8_Write(0, 41534)
    AirCon_Bleed_Show ()
end

function AirCon_Bleed_Max ()
    MJCD8_Write(2, 41534)
    AirCon_Bleed_Show ()
end

----

function AirCon_CabGauge_Show ()
    ipc.sleep(30)
    ACGaugVar = ipc.readLvar("OHD_AIR_COND_GAUGE_KNOB")
    if ACGaugVar == 20 then ACGaugTxt = "CDct" elseif
    ACGaugVar == 50 then ACGaugTxt = "Cabn" elseif
    ACGaugVar == 80 then ACGaugTxt = "FDct" end
    DspShow ("DUCT", ACGaugTxt)
end

function AirCon_CabGauge_inc ()
    ipc.sleep(30)
    ACGaugVar = ipc.readLvar("OHD_AIR_COND_GAUGE_KNOB")
    if ACGaugVar == 20 then AirCon_CabGauge_Cabin () elseif
    ACGaugVar == 50 then AirCon_CabGauge_FCDuct () end
    AirCon_CabGauge_Show ()
end

function AirCon_CabGauge_dec ()
    ipc.sleep(30)
    ACGaugVar = ipc.readLvar("OHD_AIR_COND_GAUGE_KNOB")
    if ACGaugVar == 80 then AirCon_CabGauge_Cabin () elseif
    ACGaugVar == 50 then AirCon_CabGauge_CabDuct () end
    AirCon_CabGauge_Show ()
end

function AirCon_CabGauge_CabDuct ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 61431)
end

function AirCon_CabGauge_Cabin ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 2)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 61431)
end

function AirCon_CabGauge_FCDuct ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 61431)
end
-----------
-----------

function AirCon_Packs1_Off ()
    ipc.writeLvar("OHD_AIR_COND_PACKS1_SW", 2)
    DspShow ("Pack", "1off")
end

function AirCon_Packs1_Man ()
    ipc.writeLvar("OHD_AIR_COND_PACKS1_SW", 1)
    DspShow ("Pack", "1man")
end

function AirCon_Packs1_Auto ()
    ipc.writeLvar("OHD_AIR_COND_PACKS1_SW", 0)
    DspShow ("Pack", "1aut")
end



function AirCon_Packs2_Off ()
    ipc.writeLvar("OHD_AIR_COND_PACKS2_SW", 2)
    DspShow ("Pack", "2off")
end

function AirCon_Packs2_Man ()
    ipc.writeLvar("OHD_AIR_COND_PACKS2_SW", 1)
    DspShow ("Pack", "2man")
end

function AirCon_Packs2_Auto ()
    ipc.writeLvar("OHD_AIR_COND_PACKS2_SW", 0)
    DspShow ("Pack", "2aut")
end

-----

function AirCon_Packs_All_Off ()
    AirCon_Packs1_Off ()
    _sleep(150,250)
    AirCon_Packs2_Off ()
end

function AirCon_Packs_All_Man ()
    AirCon_Packs1_Man ()
    _sleep(150,250)
    AirCon_Packs2_Man ()
end

function AirCon_Packs_All_Auto ()
    AirCon_Packs1_Auto ()
    _sleep(150,250)
    AirCon_Packs2_Auto ()
end



--- Value for all OHD lights increases/decreases
CapCompDelta = 3000          -- increases/decreases
CapCompDeltaFast = 10000     -- increases/decreases fast
CapCompMiddle = 32767             -- 32767 is 50%, 65535 is 100%
-------------------------------------------------
-------------------------------------------------
function AirCon_CabComp_show ()
    ipc.sleep(30)
    CabCompVar = ipc.readLvar("OHD_AIR_COND_TEMP_CABIN_KNOB")
    CabCompVar = round((CabCompVar*0.11)+12)
    DspShow ("Cab", CabCompVar .."C")
end

function AirCon_CabComp_inc ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 66010)
    ipc.sleep(10)
    CapCompLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if CapCompLVar < 60000 then
    CapCompLVar = CapCompLVar + CapCompDelta
    else
    CapCompLVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", CapCompLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()

end

function AirCon_CabComp_incfast ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 66010)
    ipc.sleep(10)
    CapCompLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if CapCompLVar < 55000 then
    CapCompLVar = CapCompLVar + CapCompDeltaFast
    else
    CapCompLVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", CapCompLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()
end

function AirCon_CabComp_dec ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 66010)
    ipc.sleep(10)
    CapCompLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if CapCompLVar > 5000 then
    CapCompLVar = CapCompLVar - CapCompDelta
    else
    CapCompLVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", CapCompLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()
end

function AirCon_CabComp_decfast ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 66010)
    ipc.sleep(10)
    CapCompLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if CapCompLVar > 10500 then
    CapCompLVar = CapCompLVar - CapCompDeltaFast
    else
    CapCompLVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", CapCompLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()
end

function AirCon_CabComp_0 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()
end

function AirCon_CabComp_50 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", CapCompMiddle)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()
end

function AirCon_CabComp_100 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 65535)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 66010)
    AirCon_CabComp_show ()
end

--------------------------------------------------
----


--- Value for all OHD lights increases/decreases
AirConDelta = 3000          -- increases/decreases
AirConDeltaFast = 10000     -- increases/decreases fast
AirConMiddle = 32767             -- 32767 is 50%, 65535 is 100%
-------------------------------------------------
-------------------------------------------------
function AirCon_FltComp_show ()
    ipc.sleep(30)
    FltCompVar = ipc.readLvar("OHD_AIR_COND_TEMP_FCOMP_KNOB")
    FltCompVar = round((FltCompVar*0.11)+12)
    DspShow ("Flt", FltCompVar .."C")
end

function AirCon_FltComp_inc ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 74446)
    ipc.sleep(10)
    AirConLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if AirConLVar < 60000 then
    AirConLVar = AirConLVar + AirConDelta
    else
    AirConLVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", AirConLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()

end

function AirCon_FltComp_incfast ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 74446)
    ipc.sleep(10)
    AirConLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if AirConLVar < 55000 then
    AirConLVar = AirConLVar + AirConDeltaFast
    else
    AirConLVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", AirConLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()
end

function AirCon_FltComp_dec ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 74446)
    ipc.sleep(10)
    AirConLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if AirConLVar > 5000 then
    AirConLVar = AirConLVar - AirConDelta
    else
    AirConLVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", AirConLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()
end

function AirCon_FltComp_decfast ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 74446)
    ipc.sleep(10)
    AirConLVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if AirConLVar > 10500 then
    AirConLVar = AirConLVar - AirConDeltaFast
    else
    AirConLVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", AirConLVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()
end

function AirCon_FltComp_0 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()
end

function AirCon_FltComp_50 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", AirConMiddle)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()
end

function AirCon_FltComp_100 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 65535)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 74446)
    AirCon_FltComp_show ()
end

--------------------------------------------------
----



-- ## Signs and Lights ###############

function FastenSeat_On ()
    ipc.writeLvar("OHD_EMER_LT_FASTEN_BELTS_SW", 1)
    DspShow ("Seat", "on")
end

function FastenSeat_Off ()
    ipc.writeLvar("OHD_EMER_LT_FASTEN_BELTS_SW", 0)
    DspShow ("Seat", "off")
end

function FastenSeat_toggle ()
	if _tl("OHD_EMER_LT_FASTEN_BELTS_SW", 0) then
       FastenSeat_On ()
	else
       FastenSeat_Off ()
	end
end

function NoSmoking_On ()
    ipc.writeLvar("OHD_EMER_LT_NO_SMOKING_SW", 1)
    DspShow ("Smke", "on")
end

function NoSmoking_Off ()
    ipc.writeLvar("OHD_EMER_LT_NO_SMOKING_SW", 0)
    DspShow ("Smke", "off")
end

function NoSmoking_toggle ()
	if _tl("OHD_EMER_LT_NO_SMOKING_SW", 0) then
       NoSmoking_On ()
	else
       NoSmoking_Off ()
	end
end

function Seat_and_Smoke_on ()
    FastenSeat_On ()
    _sleep(150,250)
    NoSmoking_On ()
end

function Seat_and_Smoke_off ()
    FastenSeat_Off ()
    _sleep(150,250)
    NoSmoking_Off ()
end

function Seat_and_Smoke_toggle ()
    FastenSeat_toggle ()
    _sleep(150,250)
    NoSmoking_toggle ()
end


function AdvCaut_Test_Adv ()
   ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 73126)
   DspShow ("Caut", "Adv")
end

function AdvCaut_Test_Off ()
   ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 73126)
   DspShow ("Caut", "Off")
end

function AdvCaut_Test_Caut ()
   ipc.writeLvar("MJC_VAR_WRITE_VALUE", 2)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 73126)
   DspShow ("Caut", "Caut")
end

function AdvCaut_Test_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 73126)
    ipc.sleep(10)
    CautAdvTestVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if CautAdvTestVar == 0 then CautAdvToggle = 1
    CautAdvTxt = "Advs"
    elseif CautAdvTestVar == 1 then CautAdvToggle = 2
    CautAdvTxt = "Caut"
    elseif CautAdvTestVar == 2 then CautAdvToggle = 0
    CautAdvTxt = "Off"
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", CautAdvToggle)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 73126)

    DspShow ("Test", CautAdvTxt)
end

----

------ AdvCaut_Dim currently not working
function AdvCaut_Dim ()
   ipc.writeLvar("OHD_EMER_LT_CAUT_BRT_SW", 1)

   ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 98995)
    DspShow ("Caut", "Dim")
    _sleep(100,200)
    ipc.writeLvar("OHD_EMER_LT_CAUT_BRT_SW", 0)
end

function AdvCaut_Brt ()
      ipc.writeLvar("OHD_EMER_LT_CAUT_BRT_SW", -1)

   ipc.writeLvar("MJC_VAR_WRITE_VALUE", 2)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 98995)
    DspShow ("Caut", "Brt")
    _sleep(100,200)
    ipc.writeLvar("OHD_EMER_LT_CAUT_BRT_SW", 0)
end

------------

function EmerLights_Off ()
    ipc.writeLvar("OHD_EMER_LT_ARM_SW", 1)
    DspShow ("Emer", "off")
end

function EmerLights_Arm ()
    ipc.writeLvar("OHD_EMER_LT_ARM_SW", 0)
    DspShow ("Emer", "arm")
end

function EmerLights_On ()
    ipc.writeLvar("OHD_EMER_LT_ARM_SW", -1)
    DspShow ("Emer", "on")
end

function EmerLights_Toggle ()
local EmerLtArm = ipc.readLvar("OHD_EMER_LT_ARM_SW")
    if EmerLtArm == 0 then
        EmerLights_Off()
    elseif EmerLtArm == 1 then
        EmerLights_On()
    else
        EmerLights_Arm()
    end
end

-- ## Main Index Panel ###############

function MIP_SPDBUG_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 75899)
    DspShow ("SPD", "press")
end

function MIP_SPDBUG_inc ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 43080)
    DspShow ("SPD", "inc")
end

function MIP_SPDBUG_incfast ()
    i = 0
    for i = 1,10,1 do
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 43080)
    end
    DspShow ("SPD", "inc")

end

function MIP_SPDBUG_dec ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", -1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 43080)
    DspShow ("SPD", "dec")
end

function MIP_SPDBUG_decfast ()
    i = 0
    for i = 1,10,1 do
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", -1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 43080)
    end
    DspShow ("SPD", "dec")

end

--
function MIP_BARO_std ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 141424)
    DspShow ("BARO", "std")
end

function MIP_BARO_inc ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 167545)
    DspShow ("BARO", "inc")
end

function MIP_BARO_dec ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", -1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 167545)
    DspShow ("BARO", "dec")
end


function MIP_MDHDH_DH ()
    ipc.writeLvar("MAIN_INDX1_DH_MDA_SW", 0)
    DspShow ("Set", "DH")
end

function MIP_MDHDH_MDA ()
    ipc.writeLvar("MAIN_INDX1_DH_MDA_SW", 1)
    DspShow ("Set", "MDA")
end

function MIP_MDHDH_toggle ()
	if _tl("MAIN_INDX1_DH_MDA_SW", 0) then
       MIP_MDHDH_MDA ()
	else
       MIP_MDHDH_DH ()
	end
end

function MIP_DH_inc ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 31252)
    DspShow ("DH", "inc")
end

function MIP_DH_dec ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", -1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 31252)
    DspShow ("DH", "dec")
end



-- ## Main Panel PFCS ###############

function PFCS_RUD1_press ()
    PFCSCode = 181265
    ipc.writeLvar("MJC_VAR_READ_CODE", PFCSCode)
    ipc.sleep(10)
    PFCS = ipc.readLvar("MJC_VAR_READ_VALUE")
    if PFCS == 1 then PFCSvar = 0
    PFCStxt = "on"
    elseif PFCS == 0 then PFCSvar = 1
    PFCStxt = "off"
    end

    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PFCSvar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", PFCSCode)
    DspShow ("RUD1", PFCStxt)
end

function PFCS_SPLR1_press ()
    PFCSCode = 165983
    ipc.writeLvar("MJC_VAR_READ_CODE", PFCSCode)
    ipc.sleep(10)
    PFCS = ipc.readLvar("MJC_VAR_READ_VALUE")
    if PFCS == 1 then PFCSvar = 0
    PFCStxt = "on"
    elseif PFCS == 0 then PFCSvar = 1
    PFCStxt = "off"
    end

    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PFCSvar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", PFCSCode)
    DspShow ("SPL1", PFCStxt)
end

function PFCS_SPLR2_press ()
    PFCSCode = 166025
    ipc.writeLvar("MJC_VAR_READ_CODE", PFCSCode)
    ipc.sleep(10)
    PFCS = ipc.readLvar("MJC_VAR_READ_VALUE")
    if PFCS == 1 then PFCSvar = 0
    PFCStxt = "on"
    elseif PFCS == 0 then PFCSvar = 1
    PFCStxt = "off"
    end

    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PFCSvar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", PFCSCode)
    DspShow ("SPL2", PFCStxt)
end

function PFCS_RUD2_press ()
    PFCSCode = 181101
    ipc.writeLvar("MJC_VAR_READ_CODE", PFCSCode)
    ipc.sleep(10)
    PFCS = ipc.readLvar("MJC_VAR_READ_VALUE")
    if PFCS == 1 then PFCSvar = 0
    PFCStxt = "on"
    elseif PFCS == 0 then PFCSvar = 1
    PFCStxt = "off"
    end

    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PFCSvar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", PFCSCode)
    DspShow ("RUD2", PFCStxt)
end

-- ## Pedestal Captain ###############

function Ped_NAVsourceLeft_show ()
    ipc.sleep(30)
    NavSrc1 = ipc.readLvar("PED_CPT_NAV_SRC_LFT_KNOB")
    if NavSrc1 == 0 then NavSrc1Txt = "AUX1" elseif
    NavSrc1 == 1 then NavSrc1Txt = "FMS1" elseif
    NavSrc1 == 2 then NavSrc1Txt = "ADF1" elseif
    NavSrc1 == 3 then NavSrc1Txt = "VOR1" elseif
    NavSrc1 == 4 then NavSrc1Txt = "off" end
    DspShow ("SrcL", NavSrc1Txt)
end

function Ped_NAVsourceLeft_inc ()
    Lvar = "L:PED_CPT_NAV_SRC_LFT_KNOB"
    value = ipc.readLvar(Lvar)

    if value < 4 then
        ipc.writeLvar(Lvar, value + 1)
    end
    Ped_NAVsourceLeft_show ()
end

function Ped_NAVsourceLeft_dec ()
    Lvar = "L:PED_CPT_NAV_SRC_LFT_KNOB"
    value = ipc.readLvar(Lvar)

    if value > 0 then
        ipc.writeLvar(Lvar, value - 1)
    end
    Ped_NAVsourceLeft_show ()
end

function Ped_NAVsourceLeft_toggle ()
    Lvar = "L:PED_CPT_NAV_SRC_LFT_KNOB"
    value = ipc.readLvar(Lvar)

    if value < 4 then
        ipc.writeLvar(Lvar, value + 1)
    elseif value >= 4 then
        ipc.writeLvar(Lvar, 0)
    end
    Ped_NAVsourceLeft_show ()
end

function Ped_NAVsourceRight_show ()
    ipc.sleep(30)
    NavSrc1 = ipc.readLvar("PED_CPT_NAV_SRC_RGT_KNOB")
    if NavSrc1 == 0 then NavSrc1Txt = "off" elseif
    NavSrc1 == 1 then NavSrc1Txt = "VOR2" elseif
    NavSrc1 == 2 then NavSrc1Txt = "ADF2" elseif
    NavSrc1 == 3 then NavSrc1Txt = "FMS2" elseif
    NavSrc1 == 4 then NavSrc1Txt = "AUX2" end
    DspShow ("SrcL", NavSrc1Txt)
end

function Ped_NAVsourceRight_inc ()
    Lvar = "L:PED_CPT_NAV_SRC_RGT_KNOB"
    value = ipc.readLvar(Lvar)

    if value < 4 then
        ipc.writeLvar(Lvar, value + 1)
    end
    Ped_NAVsourceRight_show ()
end

function Ped_NAVsourceRight_dec ()
    Lvar = "L:PED_CPT_NAV_SRC_RGT_KNOB"
    value = ipc.readLvar(Lvar)

    if value > 0 then
        ipc.writeLvar(Lvar, value - 1)
    end
    Ped_NAVsourceRight_show ()
end

function Ped_NAVsourceRight_toggle ()
    Lvar = "L:PED_CPT_NAV_SRC_RGT_KNOB"
    value = ipc.readLvar(Lvar)

    if value < 4 then
        ipc.writeLvar(Lvar, value + 1)
    elseif value >= 4 then
        ipc.writeLvar(Lvar, 0)
    end
    Ped_NAVsourceRight_show ()
end


------------------

function Ped_Range_show ()
    RngVar = ipc.readLvar("L:PED_CPT_RANGE_KNOB")
    if RngVar == 0 then RngTxt = "10" elseif
    RngVar == 1 then RngTxt = "20" elseif
    RngVar == 2 then RngTxt = "40" elseif
    RngVar == 3 then RngTxt = "80" elseif
    RngVar == 4 then RngTxt = "160" elseif
    RngVar == 5 then RngTxt = "240" end

    DspShow ("Rng", RngTxt)
end


function Ped_Range_inc ()
    Lvar = "L:PED_CPT_RANGE_KNOB"
    value = ipc.readLvar(Lvar)

    if value < 5 then
        ipc.writeLvar(Lvar, value + 1)
    end
    Ped_Range_show ()
end

function Ped_Range_dec ()
    Lvar = "L:PED_CPT_RANGE_KNOB"
    value = ipc.readLvar(Lvar)

    if value > 0 then
        ipc.writeLvar(Lvar, value - 1)
    end
    Ped_Range_show ()
end

--------------------------------------------------

function Ped_TCAS_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 100277)
    DspShow ("TCAS", "press")
end

function Ped_WXTERR_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 109300)
    ipc.sleep(10)
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 109300)
    DspShow ("WXTR", "press")
end

function Ped_DATA_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 99681)
    DspShow ("DATA", "press")
end

function Ped_FORMAT_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 108063)
    ipc.sleep(10)
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 108063)
    DspShow ("FRMT", "press")
end

function Ped_FORMAT_long_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 1)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 108063)
    DspShow ("FRMT", "press")
end


-- ## Display Brightness ALL ###############

function Ped_MFD1_PFD1bright_inc ()
    Ped_PFDbright_inc ()
    Ped_MFDbright_inc ()
end

function Ped_MFD2_PFD2bright_inc ()
    Ped_PFD2bright_inc ()
    Ped_MFD2bright_inc ()
end

function Ped_PFD1_PFD2bright_inc ()
    Ped_PFDbright_inc ()
    Ped_PFD2bright_inc ()
end

function Ped_MFD1_MFD2bright_inc ()
    Ped_MFDbright_inc ()
    Ped_MFD2bright_inc ()
end

function Ped_All_Panels_bright_inc ()
    Ped_MFDbright_inc ()
    Ped_PFDbright_inc ()
    Ped_MFD2bright_inc ()
    Ped_PFD2bright_inc ()
    Ped_ENGbright_inc ()
end

function Ped_All_Panels_bright_Full ()
    Ped_MFDbright_100 ()
    Ped_PFDbright_100 ()
    Ped_MFD2bright_100 ()
    Ped_PFD2bright_100 ()
    Ped_ENGbright_100 ()
end

function Ped_All_Panels_bright_50 ()
    Ped_MFDbright_50 ()
    Ped_PFDbright_50 ()
    Ped_MFD2bright_50 ()
    Ped_PFD2bright_50 ()
    Ped_ENGbright_50 ()
end

function Ped_All_Panels_bright_0 ()
    Ped_MFDbright_0 ()
    Ped_PFDbright_0 ()
    Ped_MFD2bright_0 ()
    Ped_PFD2bright_0 ()
    Ped_ENGbright_0 ()
end

---------

-------------------

function Ped_MFD1_PFD1bright_dec ()
    Ped_PFDbright_dec ()
    Ped_MFDbright_dec ()
end

function Ped_MFD2_PFD2bright_dec ()
    Ped_PFD2bright_dec ()
    Ped_MFD2bright_dec ()
end

function Ped_PFD1_PFD2bright_dec ()
    Ped_PFDbright_dec ()
    Ped_PFD2bright_dec ()
end

function Ped_MFD1_MFD2bright_dec ()
    Ped_MFDbright_dec ()
    Ped_MFD2bright_dec ()
end

function Ped_All_Panels_bright_dec ()
    Ped_MFDbright_dec ()
    Ped_PFDbright_dec ()
    Ped_MFD2bright_dec ()
    Ped_PFD2bright_dec ()
    Ped_ENGbright_dec ()
end
-------------------


-- ## Display Brightness CAPT ###############
--- Value for all Panel brightness increases/decreases
PnlBrgtDelta = 3000          -- increases/decreases
PnlBrgtDeltaFast = 10000     -- increases/decreases fast
PnlBrgtMiddle = 32767             -- 32767 is 50%, 65535 is 100%
-------------------------------------------------
-------------------------------------------------


function Ped_PFDbright_show ()
    ipc.sleep(10)
   PFD1 = round(ipc.readLvar("PED_CPT_PFD_BRT_KNOB"))
   DspShow ("PFD", PFD1 .."%")
end


function Ped_PFDbright_inc ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 78809)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar < 60000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
    PnlBrightVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()

end

function Ped_PFDbright_incfast ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 78809)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar < 55000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
    PnlBrightVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()
end

function Ped_PFDbright_dec ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 78809)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar > 5000 then
    PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
    PnlBrightVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()
end

function Ped_PFDbright_decfast ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 78809)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar > 10500 then
    PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
    PnlBrightVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()
end

function Ped_PFDbright_0 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()
end

function Ped_PFDbright_50 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrgtMiddle)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()
end

function Ped_PFDbright_100 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 65535)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78809)
    Ped_PFDbright_show ()
end

-------------------

function Ped_MFDbright_show ()
    ipc.sleep(10)
   MFD1 = round(ipc.readLvar("PED_CPT_MFD_BRT_KNOB"))
   DspShow ("MFD", MFD1 .."%")
end


function Ped_MFDbright_inc ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 78728)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar < 60000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
    PnlBrightVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()

end

function Ped_MFDbright_incfast ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 78728)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar < 55000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
    PnlBrightVar = 65535
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()
end

function Ped_MFDbright_dec ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 78728)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar > 5000 then
    PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
    PnlBrightVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()
end

function Ped_MFDbright_decfast ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 78728)
    ipc.sleep(10)
    PnlBrightVar = ipc.readLvar("MJC_VAR_READ_VALUE")

    if PnlBrightVar > 10500 then
    PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
    PnlBrightVar = 0
    end
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrightVar)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()
end

function Ped_MFDbright_0 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()
end

function Ped_MFDbright_50 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", PnlBrgtMiddle)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()
end

function Ped_MFDbright_100 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 65535)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 78728)
    Ped_MFDbright_show ()
end

-----------------------

function Ped_WX1bright_show ()
    ipc.sleep(10)
   WX1 = round(ipc.readLvar("PED_CPT_WX_BRT_KNOB"))
   DspShow ("WX1", WX1 .."%")
end

function Ped_WX1bright_inc ()
    PnlBrightVar = MJCD8_Read(89642)
    if PnlBrightVar < 60000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
    PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 89642)
    Ped_WX1bright_show ()

end

function Ped_WX1bright_incfast ()
    PnlBrightVar = MJCD8_Read(89642)
    if PnlBrightVar < 55000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 89642)
    Ped_WX1bright_show ()
end

function Ped_WX1bright_dec ()
    PnlBrightVar = MJCD8_Read(89642)
    if PnlBrightVar > 5000 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 89642)
    Ped_WX1bright_show ()
end

function Ped_WX1bright_decfast ()
    PnlBrightVar = MJCD8_Read(89642)
    if PnlBrightVar > 10500 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 89642)
    Ped_WX1bright_show ()
end

function Ped_WX1bright_0 ()
    MJCD8_Write(0, 89642)
    Ped_WX1bright_show ()
end

function Ped_WX1bright_50 ()
    MJCD8_Write(PnlBrgtMiddle, 89642)
    Ped_WX1bright_show ()
end

function Ped_WX1bright_100 ()
    MJCD8_Write(65535, 89642)
    Ped_WX1bright_show ()
end

-- ## Display Brightness FO ###############

function Ped_MFD2bright_show ()
    ipc.sleep(10)
   MFD2 = round(ipc.readLvar("PED_FO_MFD_BRT_KNOB"))
   DspShow ("MFD2", MFD2 .."%")
end

function Ped_MFD2bright_inc ()
    PnlBrightVar = MJCD8_Read(78753)
    if PnlBrightVar < 60000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 78753)
    Ped_MFD2bright_show ()
end

function Ped_MFD2bright_incfast ()
    PnlBrightVar = MJCD8_Read(78753)
    if PnlBrightVar < 55000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 78753)
    Ped_MFD2bright_show ()
end

function Ped_MFD2bright_dec ()
    PnlBrightVar = MJCD8_Read(78753)
    if PnlBrightVar > 5000 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 78753)
    Ped_MFD2bright_show ()
end

function Ped_MFD2bright_decfast ()
    PnlBrightVar = MJCD8_Read(78753)
    if PnlBrightVar > 10500 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 78753)
    Ped_MFD2bright_show ()
end

function Ped_MFD2bright_0 ()
    MJCD8_Write(0, 78753)
    Ped_MFD2bright_show ()
end

function Ped_MFD2bright_50 ()
    MJCD8_Write(PnlBrgtMiddle, 78753)
    Ped_MFD2bright_show ()
end

function Ped_MFD2bright_100 ()
    MJCD8_Write(65535, 78753)
    Ped_MFD2bright_show ()
end

-----------------------

function Ped_PFD2bright_show ()
    ipc.sleep(10)
   PFD2 = round(ipc.readLvar("PED_FO_PFD_BRT_KNOB"))
   DspShow ("PFD2", PFD2 .."%")
end

function Ped_PFD2bright_inc ()
    PnlBrightVar = MJCD8_Read(78834)
    if PnlBrightVar < 60000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
    PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 78834)
    Ped_PFD2bright_show ()
end

function Ped_PFD2bright_incfast ()
    PnlBrightVar = MJCD8_Read(78834)
    if PnlBrightVar < 55000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 78834)
    Ped_PFD2bright_show ()
end

function Ped_PFD2bright_dec ()
    PnlBrightVar = MJCD8_Read(78834)
    if PnlBrightVar > 5000 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 78834)
    Ped_PFD2bright_show ()
end

function Ped_PFD2bright_decfast ()
   ipc.writeLvar("MJC_VAR_READ_CODE", 78834)
    ipc.sleep(10)
    PnlBrightVar = MJCD8_Read(78834)
    if PnlBrightVar > 10500 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 78834)
    Ped_PFD2bright_show ()
end

function Ped_PFD2bright_0 ()
    MJCD8_Write(0, 78834)
    Ped_PFD2bright_show ()
end

function Ped_PFD2bright_50 ()
    MJCD8_Write(PnlBrgtMiddle, 78834)
    Ped_PFD2bright_show ()
end

function Ped_PFD2bright_100 ()
    MJCD8_Write(65535, 78834)
    Ped_PFD2bright_show ()
end

-----------------------

function Ped_WX2bright_show ()
    ipc.sleep(10)
    WX2 = round(ipc.readLvar("PED_FO_WX_BRT_KNOB"))
    DspShow ("WX2", WX2 .."%")
end

function Ped_WX2bright_inc ()
    PnlBrightVar = MJCD8_Read(89667)
    if PnlBrightVar < 60000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 89667)
    Ped_WX2bright_show ()
end

function Ped_WX2bright_incfast ()
    PnlBrightVar = MJCD8_Read(89667)
    if PnlBrightVar < 55000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 89667)
    Ped_WX2bright_show ()
end

function Ped_WX2bright_dec ()
    PnlBrightVar = MJCD8_Read(89667)
    if PnlBrightVar > 5000 then
    PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
    PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 89667)
    Ped_WX2bright_show ()
end

function Ped_WX2bright_decfast ()
    PnlBrightVar = MJCD8_Read(89667)
    if PnlBrightVar > 10500 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 89667)
    Ped_WX2bright_show ()
end

function Ped_WX2bright_0 ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 0)
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 89667)
    Ped_WX2bright_show ()
end

function Ped_WX2bright_50 ()
    MJCD8_Write(PnlBrgtMiddle, 89667)
    Ped_WX2bright_show ()
end

function Ped_WX2bright_100 ()
    MJCD8_Write(65535, 89667)
    Ped_WX2bright_show ()
end

-- ## Pedestal Center ###############

function TO_GA ()
    MJCD8_Write(1, 27120)
    DspShow ("TO", "GA")
end

function PITCH_Handle_open ()
    Lvar = "L:PED_PITCH_HANDLE"
    ipc.writeLvar(Lvar, 1)
end

function PITCH_Handle_close ()
    Lvar = "L:PED_PITCH_HANDLE"
    ipc.writeLvar(Lvar, 0)
end

function PITCH_RollDisc_open ()
    Lvar = "L:PED_ROLL_DISC_HANDLE"
    ipc.writeLvar(Lvar, 1)
end

function PITCH_RollDisc_close ()
    Lvar = "L:PED_ROLL_DISC_HANDLE"
    ipc.writeLvar(Lvar, 0)
end

function Controllock_lock ()
    Lvar = "L:Q400_CONTROL_LOCK"
    ipc.writeLvar(Lvar, 100)
end

function Controllock_release ()
    Lvar = "L:Q400_CONTROL_LOCK"
    ipc.writeLvar(Lvar, 0)
end


function Fuel_Tank1_AuxPump_On ()
    MJCD8_Write(1, 63194)
    DspShow ("Aux1", "on")
end

function Fuel_Tank1_AuxPump_Off ()
    MJCD8_Write(0, 63194)
    DspShow ("Aux1", "off")
end

function Fuel_Tank1_AuxPump_Toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 63194)
    ipc.sleep(10)
    FAuxPmp1 = ipc.readLvar("MJC_VAR_READ_VALUE")
	if _tl("MJC_VAR_READ_VALUE", 0) then
       Fuel_Tank1_AuxPump_On ()
	else
       Fuel_Tank1_AuxPump_Off ()
	end
end
-------------------------

function Fuel_Tank2_AuxPump_On ()
    MJCD8_Write(1, 63210)
    DspShow ("Aux2", "on")
end

function Fuel_Tank2_AuxPump_Off ()
    MJCD8_Write(0, 63210)
    DspShow ("Aux2", "off")
end

function Fuel_Tank2_AuxPump_Toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 63210)
    ipc.sleep(10)
	if _tl("MJC_VAR_READ_VALUE", 0) then
       Fuel_Tank2_AuxPump_On ()
	else
       Fuel_Tank2_AuxPump_Off ()
	end
end
-------------------------

function Fuel_Transfer_Tank1 ()
    Lvar = "L:PED_FUEL_TRANSFER_SWITCH"
    ipc.writeLvar(Lvar, -1)
end

function Fuel_Transfer_Off ()
    Lvar = "L:PED_FUEL_TRANSFER_SWITCH"
    ipc.writeLvar(Lvar, 0)
end

function Fuel_Transfer_Tank2 ()
    Lvar = "L:PED_FUEL_TRANSFER_SWITCH"
    ipc.writeLvar(Lvar, 1)
end

--// 0- nothing, 1 - MTOP, 3 RDC TOP RESET, 4 - RDC TOP DEC,
--// 5 - MCL, 6 - MCR, 7 - RDC NP

function EngControl_MTOP_press ()
    MJCD8_Write(1, 198197)
    DspShow ("MTOP", "")
end

function EngControl_RDCNpLDG_press ()
    ipc.writeLvar("MJC_VAR_WRITE_VALUE", 7)
   MJCD8_Write(7, 198197)
    DspShow ("RDC", "NP")
end

function EngControl_MCL_press ()
    MJCD8_Write(5, 198197)
    DspShow ("MCL", "")
end

function EngControl_MCR_press ()
    MJCD8_Write(6, 198197)
    DspShow ("MTOP", "")
end

function EngControl_RDC_TOP_rst ()
    MJCD8_Write(3, 198197)
    DspShow ("RdcT", "tst")
end

function EngControl_RDC_TOP_dec ()
    MJCD8_Write(4, 198197)
    DspShow ("RdcT", "dec")
end

function PropControl_1ALT_FTHR_on ()
    Lvar = "L:PED_ALT_FTHR_ONE_GUARD"
    ipc.writeLvar(Lvar, 1)
    ipc.sleep(50)
    MJCD8_Write(1, 119554)
    DspShow ("Auto", "Fthr")
end

function PropControl_1ALT_FTHR_off ()
    Lvar = "L:PED_ALT_FTHR_ONE_GUARD"
    MJCD8_Write(0, 119554)
    ipc.sleep(50)
    ipc.writeLvar(Lvar, 0)
    DspShow ("Auto", "Fthr")
end

function PropControl_AutoFTHR_on ()
    MJCD8_Write(1, 68825)
    DspShow ("Auto", "Fthr")
end

function PropControl_AutoFTHR_off ()
    MJCD8_Write(0, 68825)
    DspShow ("Auto", "Fthr")
end

function PropControl_AutoFTHR_toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 68825)
    ipc.sleep(10)
    if _tl("MJC_VAR_READ_VALUE", 0) then
       PropControl_AutoFTHR_on ()
	else
       PropControl_AutoFTHR_off ()
	end
end

function PropControl_2ALT_FTHR_on ()
    Lvar = "L:PED_ALT_FTHR_TWO_GUARD"
    ipc.writeLvar(Lvar, 1)
    ipc.sleep(50)
    MJCD8_Write(1, 119566)
    DspShow ("Auto", "Fthr")
end

function PropControl_2ALT_FTHR_off ()
    Lvar = "L:PED_ALT_FTHR_TWO_GUARD"
    MJCD8_Write(0, 119566)
    ipc.sleep(50)
    ipc.writeLvar(Lvar, 0)
    DspShow ("Auto", "Fthr")
end

function COM1_Off ()
    ipc.writeLvar("PED_COM1_MODE_KNOB", 0)
    DspShow ("COM1", "off")
end

function COM1_On ()
    ipc.writeLvar("PED_COM1_MODE_KNOB", 1)
    DspShow ("COM1", "on")
end

function COM1_Test ()
    ipc.writeLvar("PED_COM1_MODE_KNOB", 2)
    DspShow ("COM1", "test")
end

-- ## ARCDUs ###############

function ARCDU1_Mode_show ()
    ipc.sleep(30)
    arcdu1 = ipc.readLvar("RADIO1_SRC_SELECTOR")
    if arcdu1 == 0 then arcdu1TXT = "off" elseif
       arcdu1 == 1 then arcdu1TXT = "on" elseif
       arcdu1 == 2 then arcdu1TXT = "both" elseif
       arcdu1 == 3 then arcdu1TXT = "FMS" end
    DspShow ("ARCD", arcdu1TXT)
end

function ARCDU1_Mode_toggle ()
    ARCDU1 = ipc.readLvar("RADIO1_SRC_SELECTOR")
    if ARCDU1 < 3 then ARCDU1 = ARCDU1 + 1
    else ARCDU1 = 0
    end
    ipc.writeLvar("RADIO1_SRC_SELECTOR", ARCDU1)
    ARCDU1_Mode_show ()
end

function ARCDU1_Mode_off ()
    ipc.writeLvar("RADIO1_SRC_SELECTOR", 0)
    ARCDU1_Mode_show ()
end

function ARCDU1_Mode_on ()
    ipc.writeLvar("RADIO1_SRC_SELECTOR", 1)
    ARCDU1_Mode_show ()
end

function ARCDU1_Mode_both ()
    ipc.writeLvar("RADIO1_SRC_SELECTOR", 2)
    ARCDU1_Mode_show ()
end

function ARCDU1_Mode_fms ()
    ipc.writeLvar("RADIO1_SRC_SELECTOR", 3)
    ARCDU1_Mode_show ()
end

-----

function ARCDU2_Mode_show ()
    ipc.sleep(30)
    ARCDU2 = ipc.readLvar("RADIO2_SRC_SELECTOR")
    if ARCDU2 == 0 then ARCDU2TXT = "off" elseif
       ARCDU2 == 1 then ARCDU2TXT = "on" elseif
       ARCDU2 == 2 then ARCDU2TXT = "both" elseif
       ARCDU2 == 3 then ARCDU2TXT = "FMS" end
    DspShow ("ARCD", ARCDU2TXT)
end

function ARCDU2_Mode_toggle ()
    ARCDU2 = ipc.readLvar("RADIO2_SRC_SELECTOR")
    if ARCDU2 < 3 then ARCDU2 = ARCDU2 + 1
    else ARCDU2 = 0
    end
    ipc.writeLvar("RADIO2_SRC_SELECTOR", ARCDU2)
    ARCDU2_Mode_show ()
end

function ARCDU2_Mode_off ()
    ipc.writeLvar("RADIO2_SRC_SELECTOR", 0)
    ARCDU2_Mode_show ()
end

function ARCDU2_Mode_on ()
    ipc.writeLvar("RADIO2_SRC_SELECTOR", 1)
    ARCDU2_Mode_show ()
end

function ARCDU2_Mode_both ()
    ipc.writeLvar("RADIO2_SRC_SELECTOR", 2)
    ARCDU2_Mode_show ()
end

function ARCDU2_Mode_fms ()
    ipc.writeLvar("RADIO2_SRC_SELECTOR", 3)
    ARCDU2_Mode_show ()
end

-- ## Display Modes ###############

 function PED_MFD1_MODE_show ()
    ipc.sleep(30)
    PED_MFD1 = ipc.readLvar("PED_MFD1_MODE")
    if PED_MFD1 == -1 then PED_MFD1TXT = "PFD" elseif
       PED_MFD1 == 0 then PED_MFD1TXT = "NAV" elseif
       PED_MFD1 == 1 then PED_MFD1TXT = "SYS" elseif
       PED_MFD1 == 2 then PED_MFD1TXT = "ENG" end
    DspShow ("MFD1", PED_MFD1TXT)

end

function PED_MFD1_MODE_toggle ()
    PED_MFD1 = ipc.readLvar("PED_MFD1_MODE")
    if PED_MFD1 < 2 then PED_MFD1 = PED_MFD1 + 1
    else PED_MFD1 = -1
    end
    ipc.writeLvar("PED_MFD1_MODE", PED_MFD1)
    PED_MFD1_MODE_show ()
end

function PED_MFD1_MODE_pfd ()
    ipc.writeLvar("PED_MFD1_MODE", -1)
    PED_MFD1_MODE_show ()
end

function PED_MFD1_MODE_nav ()
    ipc.writeLvar("PED_MFD1_MODE", 0)
    PED_MFD1_MODE_show ()
end

function PED_MFD1_MODE_sys ()
    ipc.writeLvar("PED_MFD1_MODE", 1)
    PED_MFD1_MODE_show ()
end

function PED_MFD1_MODE_eng ()
    ipc.writeLvar("PED_MFD1_MODE", 2)
    PED_MFD1_MODE_show ()
end
-----------------

function PED_MFD_MODE_elec ()
    MJCD8_Write(1, 110571)
    DspShow ("MFD", "elec")
end

function PED_MFD_MODE_eng ()
    MJCD8_Write(1, 106867)
    DspShow ("MFD", "eng")
end

function PED_MFD_MODE_fuel ()
    MJCD8_Write(1, 111101)
    DspShow ("MFD", "fuel")
end

function PED_MFD_MODE_doors ()
    MJCD8_Write(1, 115702)
    DspShow ("MFD", "door")
end

function PED_MFD_MODE_all ()
    MJCD8_Write(1, 106849)
    DspShow ("MFD", "all")
end

-------------

function PFD_MFD2_MODE_show ()
    ipc.sleep(30)
    PED_MFD2 = ipc.readLvar("PFD_MFD2_MODE")
    if PED_MFD2 == -1 then PED_MFD2TXT = "PFD" elseif
       PED_MFD2 == 0 then PED_MFD2TXT = "NAV" elseif
       PED_MFD2 == 1 then PED_MFD2TXT = "SYS" elseif
       PED_MFD2 == 2 then PED_MFD2TXT = "ENG" end
    DspShow ("MFD2", PED_MFD2TXT)
end

function PFD_MFD2_MODE_toggle ()
    PED_MFD2 = ipc.readLvar("PFD_MFD2_MODE")
    if PED_MFD2 < 2 then
        PED_MFD2 = PED_MFD2 + 1
    else
        PED_MFD2 = -1
    end
    ipc.writeLvar("PFD_MFD2_MODE", PED_MFD2)
    PFD_MFD2_MODE_show ()
end

function PFD_MFD2_MODE_pfd ()
    ipc.writeLvar("PFD_MFD2_MODE", -1)
    PFD_MFD2_MODE_show ()
end

function PFD_MFD2_MODE_nav ()
    ipc.writeLvar("PFD_MFD2_MODE", 0)
    PFD_MFD2_MODE_show ()
end

function PFD_MFD2_MODE_sys ()
    ipc.writeLvar("PFD_MFD2_MODE", 1)
    PFD_MFD2_MODE_show ()
end

function PFD_MFD2_MODE_eng ()
    ipc.writeLvar("PFD_MFD2_MODE", 2)
    PFD_MFD2_MODE_show ()
end
--------------

function Ped_ENGbright_show ()
    ipc.sleep(10)
   ENG1 = round(ipc.readLvar("PED_ED_BRT"))
   DspShow ("ENG", ENG1 .."%")
end

function Ped_ENGbright_inc ()
    PnlBrightVar = MJCD8_Read(71965)

    if PnlBrightVar < 60000 then
        PnlBrightVar = PnlBrightVar + PnlBrgtDelta
    else
        PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 71965)
    Ped_ENGbright_show ()

end

function Ped_ENGbright_incfast ()
    PnlBrightVar = MJCD8_Read(71965)

    if PnlBrightVar < 55000 then
    PnlBrightVar = PnlBrightVar + PnlBrgtDeltaFast
    else
    PnlBrightVar = 65535
    end
    MJCD8_Write(PnlBrightVar, 71965)
    Ped_ENGbright_show ()
end

function Ped_ENGbright_dec ()
    PnlBrightVar = MJCD8_Read(71965)
    if PnlBrightVar > 5000 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDelta
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 71965)
    Ped_ENGbright_show ()
end

function Ped_ENGbright_decfast ()
    PnlBrightVar = MJCD8_Read(71965)
    if PnlBrightVar > 10500 then
        PnlBrightVar = PnlBrightVar - PnlBrgtDeltaFast
    else
        PnlBrightVar = 0
    end
    MJCD8_Write(PnlBrightVar, 71965)
    Ped_ENGbright_show ()
end

function Ped_ENGbright_0 ()
    MJCD8_Write(0, 71965)
    Ped_ENGbright_show ()
end

function Ped_ENGbright_50 ()
    MJCD8_Write(PnlBrgtMiddle, 71965)
    Ped_ENGbright_show ()
end

function Ped_ENGbright_100 ()
    MJCD8_Write(65535, 71965)
    Ped_ENGbright_show ()
end

-- ## WX ###############

function WX_Mode_show ()
    ipc.sleep(30)
    WX = ipc.readLvar("PED_WR_MODE")
    if WX == 0 then WXTXT = "off" elseif
       WX == 1 then WXTXT = "stby" elseif
       WX == 2 then WXTXT = "test" elseif
       WX == 3 then WXTXT = "on" end
    DspShow ("WX", WXTXT)
end

function WX_Mode_toggle ()
    WX = ipc.readLvar("PED_WR_MODE")
    if WX < 3 then
        WX = WX + 1
    else
        WX = 0
    end
    ipc.writeLvar("PED_WR_MODE", WX)
    WX_Mode_show ()
end

function WX_Mode_off ()
    ipc.writeLvar("PED_WR_MODE", 0)
    WX_Mode_show ()
end

function WX_Mode_stby ()
    ipc.writeLvar("PED_WR_MODE", 1)
    WX_Mode_show ()
end

function WX_Mode_test ()
    ipc.writeLvar("PED_WR_MODE", 2)
    WX_Mode_show ()
end

function WX_Mode_on ()
    ipc.writeLvar("PED_WR_MODE", 3)
    WX_Mode_show ()
end

-- ## Captain Side Panel ###############
--- Value for all CptSide lights increases/decreases
CptSLightDelta = 3000          -- increases/decreases
CptSLightDeltaFast = 10000     -- increases/decreases fast
CptSMiddle = 32767             -- 32767 is 50%, 65535 is 100%
-------------------------------------------------
-------------------------------------------------

function CaptSide_InstrLight_show ()
    CaptSL = round2(MJCD8_Read(88848)/655.35)
    DspShow ("InsL", CaptSL.."%")
end

function CaptSide_InstrLight_inc ()
    CptSlightVar = MJCD8_Read(88848)

    if CptSlightVar < 60000 then
    CptSlightVar = CptSlightVar + CptSLightDelta
    else
    CptSlightVar = 65535
    end
    MJCD8_Write(CptSlightVar, 88848)
    CaptSide_InstrLight_show ()

end

function CaptSide_InstrLight_incfast ()
    CptSlightVar = MJCD8_Read(88848)
    if CptSlightVar < 55000 then
    CptSlightVar = CptSlightVar + CptSLightDeltaFast
    else
    CptSlightVar = 65535
    end
    MJCD8_Write(CptSlightVar, 88848)
    CaptSide_InstrLight_show ()
end

function CaptSide_InstrLight_dec ()
    CptSlightVar = MJCD8_Read(88848)
    if CptSlightVar > 5000 then
    CptSlightVar = CptSlightVar - CptSLightDelta
    else
    CptSlightVar = 0
    end
    MJCD8_Write(CptSlightVar, 88848)
    CaptSide_InstrLight_show ()
end

function CaptSide_InstrLight_decfast ()
    CptSlightVar = MJCD8_Read(88848)
    if CptSlightVar > 10500 then
        CptSlightVar = CptSlightVar - CptSLightDeltaFast
    else
        CptSlightVar = 0
    end
    MJCD8_Write(CptSlightVar, 88848)
    CaptSide_InstrLight_show ()
end

function CaptSide_InstrLight_0 ()
    MJCD8_Write(0, 88848)
    CaptSide_InstrLight_show ()
end

function CaptSide_InstrLight_50 ()
    MJCD8_Write(CptSMiddle, 88848)
    CaptSide_InstrLight_show ()
end

function CaptSide_InstrLight_100 ()
    MJCD8_Write(65535, 88848)
    CaptSide_InstrLight_show ()
end

----------------------------

function CaptLeft_CIRBRKLight_On ()
    MJCD8_Write(1, 83731)
    DspShow ("CiLt", "on")
end

function CaptLeft_CIRBRKLight_Off ()
    MJCD8_Write(0, 83731)
    DspShow ("CiLt", "on")
end

function CaptLeft_PropOSpeedGov_Test_On ()
    Lvar = "L:SIDE_PNL_PROP_OSG"
    ipc.writeLvar(Lvar, -1)
    DspShow ("test", "on")
end

function CaptLeft_PropOSpeedGov_Test_Off ()
    Lvar = "L:SIDE_PNL_PROP_OSG"
    ipc.writeLvar(Lvar, 0)
    DspShow ("test", "off")
end

function CaptLeft_PropOSpeedGov_Test_toggle ()
	if _tl("SIDE_PNL_PROP_OSG", -1) then
        CaptLeft_PropOSpeedGov_Test_Off ()
	else
        CaptLeft_PropOSpeedGov_Test_On ()
	end
end

function CaptLeft_TOWarn_Test_on ()
    Lvar = "L:SIDE_PNL_TO_WARN"
    ipc.writeLvar(Lvar, 1)
    DspShow ("TO", "warn")
end

function CaptLeft_TOWarn_Test_off ()
    Lvar = "L:SIDE_PNL_TO_WARN"
    ipc.writeLvar(Lvar, 0)
end

function CaptLeft_TOWarn_Test_toggle ()
	if _tl("SIDE_PNL_TO_WARN", 0) then
        CaptLeft_TOWarn_Test_on ()
	else
        CaptLeft_TOWarn_Test_off ()
	end
end

function CaptLeft_ADC_Test1 ()
    Lvar = "L:SIDE_PNL_ADC_TEST"
    ipc.writeLvar(Lvar, 1)
    DspShow ("ADC", "tst1")
end

function CaptLeft_ADC_Test_off ()
    Lvar = "L:SIDE_PNL_ADC_TEST"
    ipc.writeLvar(Lvar, 0)
    DspShow ("ADC", "off")
end

function CaptLeft_ADC_Test2 ()
    Lvar = "L:SIDE_PNL_ADC_TEST"
    ipc.writeLvar(Lvar, -1)
    DspShow ("ADC", "tst2")
end

function CaptLeft_StallWarn_Test1 ()
    Lvar = "L:SIDE_PNL_STALL_WARN_TEST"
    ipc.writeLvar(Lvar, 1)
    DspShow ("Stll", "tst1")
end

function CaptLeft_StallWarn_off ()
    Lvar = "L:SIDE_PNL_STALL_WARN_TEST"
    ipc.writeLvar(Lvar, 0)
    DspShow ("Stll", "off")
end

function CaptLeft_StallWarn_Test2 ()
    Lvar = "L:SIDE_PNL_STALL_WARN_TEST"
    ipc.writeLvar(Lvar, -1)
    DspShow ("Stll", "tst2")
end

function CaptLeft_NoseWheelSteering_On ()
    Lvar = "L:SIDE_PNL_STEERING"
    ipc.writeLvar(Lvar, 1)
    DspShow ("Ster", "on")
end

function CaptLeft_NoseWheelSteering_Off ()
    Lvar = "L:SIDE_PNL_STEERING"
    ipc.writeLvar(Lvar, 0)
    DspShow ("Ster", "on")
end

-- ## Landing Gear ###############

function Other_GearHandle_down ()
    Other_GearLock_down()
    Lvar = "L:MAIN_GEAR_HANDLE_POS"
    ipc.writeLvar(Lvar, 1)
    Gears_down()
    ipc.sleep(50)
    Other_GearLock_up()
    DspShow ("Gear", "down")
end

function Other_GearHandle_up ()
    Other_GearLock_down()
    Lvar = "L:MAIN_GEAR_HANDLE_POS"
    ipc.writeLvar(Lvar, 0)
    Gears_up()
    ipc.sleep(50)
    Other_GearLock_up()
    DspShow ("Gear", "up")
end

function Other_GearLock_down ()
    Lvar = "L:MAIN_GEAR_LOCK_POS"
    ipc.writeLvar(Lvar, 1)
    DspShow ("Gear", "Lock")
end

function Other_GearLock_up ()
    Lvar = "L:MAIN_GEAR_LOCK_POS"
    ipc.writeLvar(Lvar, 0)
    DspShow ("Gear", "ULck")
end

function Other_GPWSLandingFlap_10 ()
    Lvar = "L:MAIN_GPWS_FLAP_SLCTR_POS"
    ipc.writeLvar(Lvar, 0)
    DspShow ("GPWS", "F:10")
end

function Other_GPWSLandingFlap_15 ()
    Lvar = "L:MAIN_GPWS_FLAP_SLCTR_POS"
    ipc.writeLvar(Lvar, 1)
    DspShow ("GPWS", "F:15")
end

function Other_GPWSLandingFlap_35 ()
    Lvar = "L:MAIN_GPWS_FLAP_SLCTR_POS"
    ipc.writeLvar(Lvar, 2)
    DspShow ("GPWS", "F:35")
end

function Other_GPWSLandingFlap_inc ()
    Lvar = "L:MAIN_GPWS_FLAP_SLCTR_POS"
    GPWSFlapvar = ipc.readLvar(Lvar)
    if GPWSFlapvar == 0 then GPWSFlapvar = 1 GPWSFlaptxt = "15"
    elseif GPWSFlapvar == 1 then GPWSFlapvar = 2 GPWSFlaptxt = "35"
    end
    ipc.writeLvar(Lvar, GPWSFlapvar)
    DspShow ("GPWS", "F:"..GPWSFlaptxt, "GPWSLdng", "Flap "..GPWSFlaptxt)
end

function Other_GPWSLandingFlap_dec ()
    Lvar = "L:MAIN_GPWS_FLAP_SLCTR_POS"
    GPWSFlapvar = ipc.readLvar(Lvar)
    if GPWSFlapvar == 2 then GPWSFlapvar = 1 GPWSFlaptxt = "15"
    elseif GPWSFlapvar == 1 then GPWSFlapvar = 0 GPWSFlaptxt = "10"
    end
    ipc.writeLvar(Lvar, GPWSFlapvar)
    DspShow ("GPWS", "F:"..GPWSFlaptxt, "GPWSLdng", "Flap "..GPWSFlaptxt)
end

function HydCTRL_STBYHYD_On ()
    MJCD8_Write(1, 81038)
    DspShow ("SHyd", "on")
end

function HydCTRL_STBYHYD_Off ()
    MJCD8_Write(0, 81038)
    DspShow ("SHyd", "off")
end

function HydCTRL_STBYHYD_Toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 81038)
    ipc.sleep(10)
    STbyHyd = ipc.readLvar("MJC_VAR_READ_VALUE")
	if _tl("MJC_VAR_READ_VALUE", 0) then
        HydCTRL_STBYHYD_On ()
	else
        HydCTRL_STBYHYD_Off ()
	end
end

function HydCTRL_PTUCNTRL_On ()
    MJCD8_Write(1, 61497)
    DspShow ("PTU", "on")
end

function HydCTRL_PTUCNTRL_Off ()
    MJCD8_Write(0, 61497)
    DspShow ("PTU", "off")
end

function HydCTRL_PTUCNTRL_Toggle ()
    ipc.writeLvar("MJC_VAR_READ_CODE", 61497)
    ipc.sleep(10)
    STbyHyd = ipc.readLvar("MJC_VAR_READ_VALUE")
	if _tl("MJC_VAR_READ_VALUE", 0) then
        HydCTRL_PTUCNTRL_On ()
	else
        HydCTRL_PTUCNTRL_Off ()
	end
end

function HydCTRL_HYDISOL_VLV_On ()
    Lvar = "L:MAIN_ALTERNATE_STATIC_POS"
    ipc.writeLvar(Lvar, 1)
    _sleep(100,200)
    MJCD8_Write(1, 116763)
    DspShow ("Hydr", "N3")
end

function HydCTRL_HYDISOL_VLV_Off ()
    Lvar = "L:MAIN_ALTERNATE_STATIC_POS"
    MJCD8_Write(0, 116763)
    _sleep(100,200)
    ipc.writeLvar(Lvar, 0)
    DspShow ("Hydr", "N3")
end

-- ## Other###############

function Avionics_on ()
    COM1_On ()
    _sleep(150,250)
    ARCDU1_Mode_fms ()
    _sleep(150,250)
    ARCDU2_Mode_fms ()
    _sleep(150,250)
    WX_Mode_stby ()
end

function Avionics_off ()
    COM1_Off ()
    _sleep(150,250)
    ARCDU1_Mode_off ()
    _sleep(150,250)
    ARCDU2_Mode_off ()
    _sleep(150,250)
    WX_Mode_off ()
end

function GPU_PWR_on ()
    MJCD8_Write(1, 41009)
    DspShow ("GPU", "on")
end

function GPU_PWR_off ()
    MJCD8_Write(0, 41009)
    DspShow ("GPU", "off")
end

function GPU_PWR_toggle ()
    ipc.writeLvar("MJC_VAR_WRITE_CODE", 41009)
    ipc.sleep(10)
    if _tl("MJC_VAR_WRITE_VALUE", 0) then
        GPU_PWR_on ()
	else
        GPU_PWR_off ()
	end
end

function PFD_AltUnits_ft ()
    ipc.writeLvar("OHD_PFD_ALT_UNITS_SW", 0)
    DspShow ("Unit", "feet")
end

function PFD_AltUnits_ftMeter ()
    ipc.writeLvar("OHD_PFD_ALT_UNITS_SW", 1)
    DspShow ("Unit", "mtr")
end

function PFD_AltUnits_toggle ()
	if _tl("OHD_PFD_ALT_UNITS_SW", 0) then
       PFD_AltUnits_ftMeter ()
	else
       PFD_AltUnits_ft ()
	end
end

function Ext_Power_and_Air_on ()
    DC_ExtPower_On ()
    _sleep(200,400)
    AC_ExtPower_On ()
end

function Ext_Power_and_Air_off ()
    DC_ExtPower_Off ()
    _sleep(200,400)
    AC_ExtPower_Off ()
end

function Ext_Power_and_Air_toggle ()
    DC_ExtPower_toggle ()
    _sleep(200,400)
    AC_ExtPower_Toggle ()
end

function Q400_YOKE_VISIBILITY_on ()
    ipc.writeLvar("Q400_YOKE_VISIBILITY", 0)
    DspShow ("Yoke", "vsbl")
end

function Q400_YOKE_VISIBILITY_off ()
    ipc.writeLvar("Q400_YOKE_VISIBILITY", 1)
    DspShow ("Yoke", "off")
end

function Q400_YOKE_VISIBILITY_toggle ()
	if _tl("Q400_YOKE_VISIBILITY", 1) then
        Q400_YOKE_VISIBILITY_on ()
	else
        Q400_YOKE_VISIBILITY_off ()
	end
end

function SideWdwDeMist_upper_on ()
    ipc.writeLvar("Q400_LEVER_ANTIMIST", 1)
    DspShow ("DMst", "U on")
end

function SideWdwDeMist_upper_off ()
    ipc.writeLvar("Q400_LEVER_ANTIMIST", 0)
    DspShow ("DMst", "Uoff")
end

function SideWdwDeMist_upper_toggle ()
	if _tl("Q400_LEVER_ANTIMIST", 0) then
       SideWdwDeMist_upper_on ()
	else
       SideWdwDeMist_upper_off ()
	end
end

---

function SideWdwDeMist_lower_on ()
    ipc.writeLvar("Q400_LOW_VENT_HANDLE", 1)
    DspShow ("DMst", "L on")
end

function SideWdwDeMist_lower_off ()
    ipc.writeLvar("Q400_LOW_VENT_HANDLE", 0)
    DspShow ("DMst", "Loff")
end

function SideWdwDeMist_lower_toggle ()
	if _tl("Q400_LOW_VENT_HANDLE", 0) then
        SideWdwDeMist_lower_on ()
	else
        SideWdwDeMist_lower_off ()
	end
end

function SideWdwDeMist_both_on ()
    SideWdwDeMist_upper_on ()
    SideWdwDeMist_lower_on ()
end

function SideWdwDeMist_both_off ()
    SideWdwDeMist_upper_off ()
    SideWdwDeMist_lower_off ()
end

-- ## Clock ###############

function MJC_Clock_CHR_press ()
    MJCD8_Write(1, 75374)
    DspShow ("clck", "", "clock", "press")
end

function MJC_FLTTime_hrs_show ()
    MJCtestVar = MJCD8_Read(53202)
    DspShow ("hrs", MJCtestVar)
end

-- ## HUD ###############

function HUD_on ()
    Lvar = "L:Q400_HUD"
    ipc.writeLvar(Lvar, 1)
    DspShow ("HUD", "on")
end

function HUD_off ()
    Lvar = "L:Q400_HUD"
    ipc.writeLvar(Lvar, 0)
    DspShow ("HUD", "off")
end

function HUD_Toggle ()
	if _tl("Q400_HUD", 0) then
       HUD_on ()
	else
       HUD_off ()
	end
end

-- ## Sun shields ###############

function Capt_SunShield_show ()
    ipc.sleep(10)
    SunSL = ipc.readLvar("Q400_SUN_SHIELD_LEFT", 0)
    DspShow ("SunS", SunSL)
end

function Capt_SunShield_pos_0 ()
    ipc.writeLvar("Q400_SUN_SHIELD_LEFT", 0)
    Capt_SunShield_show ()
end

function Capt_SunShield_pos_1 ()
    ipc.writeLvar("Q400_SUN_SHIELD_LEFT", 1)
    Capt_SunShield_show ()
end

function Capt_SunShield_pos_2 ()
    ipc.writeLvar("Q400_SUN_SHIELD_LEFT", 2)
    Capt_SunShield_show ()
end

function Capt_SunShield_pos_3 ()
    ipc.writeLvar("Q400_SUN_SHIELD_LEFT", 3)
    Capt_SunShield_show ()
end

function Capt_SunShield_pos_4 ()
    ipc.writeLvar("Q400_SUN_SHIELD_LEFT", 4)
    Capt_SunShield_show ()
end

function Capt_SunShield_toggle ()
    SunST = ipc.readLvar("Q400_SUN_SHIELD_LEFT")
    if SunST < 4 then
        SunST = SunST + 1
    else
        SunST = 0
    end
    ipc.writeLvar("Q400_SUN_SHIELD_LEFT", SunST)
    Capt_SunShield_show ()
end

function Fo_SunShield_show ()
    ipc.sleep(10)
    SunSR = ipc.readLvar("Q400_SUN_SHIELD_RIGHT", 0)
    DspShow ("SunS", SunSR)
end

function Fo_SunShield_pos_0 ()
    ipc.writeLvar("Q400_SUN_SHIELD_RIGHT", 0)
    Fo_SunShield_show ()
end

function Fo_SunShield_pos_1 ()
    ipc.writeLvar("Q400_SUN_SHIELD_RIGHT", 1)
    Fo_SunShield_show ()
end

function Fo_SunShield_pos_2 ()
    ipc.writeLvar("Q400_SUN_SHIELD_RIGHT", 2)
    Fo_SunShield_show ()
end

function Fo_SunShield_pos_3 ()
    ipc.writeLvar("Q400_SUN_SHIELD_RIGHT", 3)
    Fo_SunShield_show ()
end

function Fo_SunShield_pos_4 ()
    ipc.writeLvar("Q400_SUN_SHIELD_RIGHT", 4)
    Fo_SunShield_show ()
end

function Fo_SunShield_toggle ()
    SunSTR = ipc.readLvar("Q400_SUN_SHIELD_RIGHT")
    if SunSTR < 4 then
        SunSTR = SunSTR + 1
    else
        SunSTR = 0
    end
    ipc.writeLvar("Q400_SUN_SHIELD_RIGHT", SunSTR)
    Fo_SunShield_show ()
end

-- ## Doors ###############



function Exit_FWD_L_open ()
    ipc.sleep(500)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 1 and MJCdoor ~= 3 and MJCdoor ~= 5 and MJCdoor ~= 9 then
    ipc.control(66389)
    ipc.control(65538)
    end
    DspShow ("FwdL", "open", "FWD L", "open")
end

function Exit_FWD_L_close ()
    ipc.sleep(500)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor == 1 or MJCdoor == 3 or MJCdoor == 5 or MJCdoor == 9 then
    ipc.control(66389)
    ipc.control(65538)
    end
    DspShow ("FwdL", "clse", "FWD L", "close")
end

function Exit_FWD_L_toggle ()
    ipc.sleep(500)
    ipc.control(66389)
    ipc.control(65538)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 1 and MJCdoor ~= 3 and MJCdoor ~= 5 and MJCdoor ~= 9 then
    DspShow ("FwdL", "open", "FWD L", "open")
    else
    DspShow ("FwdL", "clse", "FWD L", "close")
    end

end


function Cargo_open ()
    ipc.sleep(500)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 2 and MJCdoor ~= 3 and MJCdoor ~= 6 and MJCdoor ~= 10 then
    ipc.control(66389)
    ipc.control(65539)
    end
    DspShow ("Crgo", "open", "Cargo", "open")
end

function Cargo_close ()
    ipc.sleep(500)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor == 2 or MJCdoor == 3 or MJCdoor == 6 or MJCdoor == 10 then
    ipc.control(66389)
    ipc.control(65539)
    end
    DspShow ("Crgo", "clse", "Cargo", "close")
end

function Cargo_toggle ()
    ipc.sleep(500)
    ipc.control(66389)
    ipc.control(65539)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 2 and MJCdoor ~= 3 and MJCdoor ~= 6 and MJCdoor ~= 10 then
    DspShow ("Crgo", "open", "Cargo", "open")
    else
    DspShow ("Crgo", "clse", "Cargo", "close")
    end
end


function Exit_AFT_L_open ()
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 4 and MJCdoor ~= 5 and MJCdoor ~= 6 and MJCdoor ~= 12 then
    ipc.control(66389)
    ipc.control(65540)
    end
    DspShow ("AftL", "open", "AFT L", "open")
end

function Exit_AFT_L_close ()
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor == 4 or MJCdoor == 5 or MJCdoor == 6 or MJCdoor == 12 then
    ipc.control(66389)
    ipc.control(65540)
    end
    DspShow ("AftL", "clse", "AFT L", "close")
end

function Exit_AFT_L_toggle ()
    ipc.control(66389)
    ipc.control(65540)
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 4 and MJCdoor ~= 5 and MJCdoor ~= 6 and MJCdoor ~= 12 then
    DspShow ("AftL", "open", "AFT L", "open")
    else
    DspShow ("AftL", "clse", "AFT L", "close")
    end
end

function Exits_R_open ()
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor ~= 8 and MJCdoor ~= 9 and MJCdoor ~= 10 and MJCdoor ~= 12 then
    ipc.control(66389)
    ipc.control(65541)
    end
    DspShow ("Rght", "open", "Doors R", "open")
end

function Exits_R_close ()
    MJCdoor = ipc.readUB(0x3367)
    if MJCdoor == 8 or MJCdoor == 9 or MJCdoor == 10 or MJCdoor == 12 then
    ipc.control(66389)
    ipc.control(65541)
    end
    DspShow ("Rght", "clse", "Doors R", "close")
end

function Exits_R_toggle ()
    ipc.control(66389)
    ipc.control(65541)
    MJCdoor = ipc.readUB(0x3367)

    if MJCdoor ~= 8 and MJCdoor ~= 9 and MJCdoor ~= 10 and MJCdoor ~= 12 then
    DspShow ("Rght", "open", "Doors R", "open")
    else
    DspShow ("Rght", "clse", "Doors R", "close")
    end
end



-- ## Cold and Dark ###############
function MJC_cold_and_dark ()
    -- set general sleep time between
	sleepVal = 100
    ipc.display("Cold & Dark Sequence initiated...")
    ipc.sleep(2000)
    questvar = ipc.ask("Captain, do you want to go Cold & Dark? (y / n)")

    if questvar == "y" then
	   ipc.display ("Please wait, going Cold & Dark!")
	   ipc.sleep(250)
        ---------------- start
        sleepVal = 100
        s1 = 200
        s2 = 400
	   ipc.display ("Please wait, going Cold & Dark!\n Displays off:")
        Ped_All_Panels_bright_0 ()
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set")
        ipc.sleep(sleepVal)
        _sleep(s1,s2)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off:")
        Avionics_off ()
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set")
        _sleep(s1,s2)
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off:")
        Ext_Power_and_Air_off ()
        _sleep(s1,s2)
        GPU_PWR_off ()
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set")
        _sleep(s1,s2)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set \n Internal lights off:")
        OHD_PanelL_All_0 ()
        _sleep(s1,s2)
        Panel_Light_ALLStormDome_Off ()
        _sleep(s1,s2)
        EmerLights_Off ()
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set \n Internal lights off: set")
        _sleep(s1,s2)
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set \n Internal lights off: set \n DC Controll all off:")
        DC_AllGen_Off ()
        _sleep(s1,s2)
        DC_MainBusTIE_Off ()
        _sleep(s1,s2)
        DC_StbyBatt_Off ()
        _sleep(s1,s2)
        DC_AUXBatt_Off ()
        _sleep(s1,s2)
        DC_MainBatt_Off ()
        _sleep(s1,s2)
        DC_BattMaster_Off ()
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set \n Internal lights off: set \n DC Controll all off: set")
        _sleep(s1,s2)
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set \n Internal lights off: set \n DC Controll all off: set \n Control Lock: ")
        Controllock_lock ()
        ipc.sleep(sleepVal)
        ipc.display ("Please wait, going Cold & Dark!\n Displays off: set \n Avionics off: set \n External Connections off: set \n Internal lights off: set \n DC Controll all off: set \n Control Lock: set")
        ipc.sleep(sleepVal)
        ---------------- end
        ipc.display("Cold & Dark READY!\n Thanks for your patience, Captain!")
        ipc.sleep(2000)
        ipc.display ("")
        ----negative --------------------------
    elseif questvar ~= "y" then
        ipc.display("Ok, was just a question, Sir!\nHave a nice day...")
        ipc.sleep(2000)
    end
    ipc.display("")
end


-- ## GSX Door Service ###############
-- $$ do not assign to hardware
-- $$ Specific Addon Settings

function GSX_Door_Service ()

    ------- comment/uncomment what you need for your addon
     --GSX_show ()
     GSX_Deboarding ()
     --GSX_Catering_front ()
     GSX_Catering_back ()
     GSX_Refueling ()
     GSX_Boarding ()
end

function GSX_Door_R_Front_open ()
     Exits_R_open ()
end

function GSX_Door_R_Front_close ()
     Exits_R_close ()
end

function GSX_Door_R_Back_open ()
     Exits_R_open ()
end

function GSX_Door_R_Back_close ()
     Exits_R_close ()
end

function GSX_Door_L_open ()
     Exit_FWD_L_open ()
end

function GSX_Door_L_close ()
     Exit_FWD_L_close ()
end

function GSX_Cargo_open ()
     Cargo_open ()
end

function GSX_Cargo_close ()
     Cargo_close ()
end

function GSX_Action_Tanker ()
    ipc.sleep(500)
    DspShow ("MJC", "ctrl", "open MJC", "ctrl pnl")
    ext.run("F:\\Prepar3D v3\\SimObjects\\Airplanes\\mjc8q400\\cpan\\mjc84cpan.exe")

end

-- $$ GSX Door functions



function GSX_Catering_front ()

    GSXCatering = ipc.readLvar('FSDT_GSX_CATERING_STATE')
    GSXCatTruck1 = ipc.readLvar('FSDT_Catering_truck_catwalk1')
    GSXManWalk1 = ipc.readLvar('FSDT_Catering_truck_man1')
    CatManCount1 = ipc.get("CatManCount1")
    CatPhase1 = ipc.get("CatPhase1")
	if GSXCatTruck1 == nil then GSXCatTruck1 = 0 end

    -- open door front
    if GSXCatTruck1 > 0 and GSXCatTruck1 < 99 and CatPhase1 == 0 then
        ipc.set("CatPhase1", 1)
        GSX_Door_R_Front_open ()
    end

    -- close doors front
    if CatManCount1 < 3 and CatPhase1 == 1 then
            if GSXManWalk1 == 1000 then
            CatManCount1 = CatManCount1 + 1
            ipc.set("CatManCount1", CatManCount1)
            ipc.sleep(2000)
            end
    elseif CatManCount1 == 3 and GSXCatTruck1 == 100 then
        ipc.set("CatPhase1", 2)
    end

    if CatPhase1 == 2 and GSXCatTruck1 == 100 then
        GSX_Door_R_Front_close ()

    elseif CatPhase1 == 2 and GSXCatTruck1 == 0 then
        ipc.set("CatManCount1",0)
        ipc.set("CatPhase1", 0)
    end

end



function GSX_Catering_back ()

    GSXCatering = ipc.readLvar('FSDT_GSX_CATERING_STATE')
    GSXCatTruck2 = ipc.readLvar('FSDT_Catering_truck_catwalk2')
    GSXManWalk2 = ipc.readLvar('FSDT_Catering_truck_man2')
    CatManCount2 = ipc.get("CatManCount2")
    CatPhase2 = ipc.get("CatPhase2")
	if GSXCatTruck2 == nil then GSXCatTruck2 = 0 end

    -- open door back
    if GSXCatTruck2 > 0 and GSXCatTruck2 < 99 and CatPhase2 == 0 then
        ipc.set("CatPhase2", 1)
        GSX_Door_R_Back_open ()
    end

    -- close doors back
    if CatManCount2 < 3 and CatPhase2 == 1 then
            if GSXManWalk2 == 1000 then
            CatManCount2 = CatManCount2 + 1
            ipc.set("CatManCount2", CatManCount2)
            ipc.sleep(2000)
            end
    elseif CatManCount2 == 3 and GSXCatTruck2 == 100 then
        ipc.set("CatPhase2", 2)
    end

    if CatPhase2 == 2 and GSXCatTruck2 == 100 then
        GSX_Door_R_Back_close ()

    elseif CatPhase2 == 2 and GSXCatTruck2 == 0 then
        ipc.set("CatManCount2",0)
        ipc.set("CatPhase2", 0)
    end

end





function GSX_Refueling ()

    --- GSX Refueling
    GSXTankerVar = ipc.readLvar('FSDT_GSX_REFUELING_STATE')
    GSXHoseVar = ipc.readLvar('FSDT_FuelHose')
    if GSXHoseVar == nil then GSXHoseVar = 0 end

    GSXFuelTrailerVar = ipc.readLvar('FSDT_FuelTrailerNeedle')
    if GSXFuelTrailerVar == nil then GSXFuelTrailerVar = 0 end

    GSXTanker = ipc.get("GSXTanker")
    if GSXTankerVar == 5 and GSXTanker == 0 then
        if GSXHoseVar >= 85 or GSXFuelTrailerVar >= 85 then
            ipc.set("GSXTanker", 1)

            GSXRefuelTestTxt = "executing action"
            GSX_Action_Tanker ()
        end
    elseif GSXTankerVar ~= 5 and GSXTanker == 1 then
    ipc.set("GSXTanker", 0)
    end
end


function GSX_Boarding ()

    GSXBoardingVar = ipc.readLvar('FSDT_GSX_BOARDING_STATE')


    GSXBoard = ipc.get("GSXBoard")
    if GSXBoardingVar == 4 and GSXBoard == 0 then

    ipc.sleep(1000)
    GSX_Door_L_open ()
    ipc.sleep(1000)
    GSX_Cargo_open ()
    ipc.set("GSXBoard", 1)

    elseif GSXBoardingVar == 6 and GSXBoard == 1 then

    ipc.sleep(1000)
    GSX_Door_L_close ()
    ipc.sleep(1000)
    GSX_Cargo_close ()
    ipc.set("GSXBoard", 0)
    end

end

function GSX_Deboarding ()

    GSXdeboard = ipc.get("GSXDeboard")
    GSXdeboardingVar = ipc.readLvar('FSDT_GSX_DEBOARDING_STATE')

    if GSXdeboardingVar == 4 and GSXdeboard == 0 then

    ipc.sleep(1000)
    GSX_Door_L_open ()
    ipc.sleep(1000)
    GSX_Cargo_open ()
    ipc.sleep(1000)
    ipc.set("GSXDeboard", 1)

    elseif GSXdeboardingVar == 6 and GSXdeboard == 1 then

    ipc.sleep(1000)
    GSX_Cargo_close ()
    ipc.sleep(1000)
    GSX_Door_L_close ()
    ipc.set("GSXDeboard", 0)
    end

end

-- $$ GSX dignostics

function GSX_show ()
    -- deboarding
    GSXdeboardingVar = ipc.readLvar('FSDT_GSX_DEBOARDING_STATE')
    if GSXdeboardingVar == 1 then GSXdeboardTxt = "off"
    elseif GSXdeboardingVar == 3 then GSXdeboardTxt = "no longer avail"
    elseif GSXdeboardingVar == 4 then GSXdeboardTxt = "deboarding"
    elseif GSXdeboardingVar == 6 then GSXdeboardTxt = "completed"
    else GSXdeboardTxt = GSXdeboardingVar
    end

    -- catering
    GSXCatering = ipc.readLvar('FSDT_GSX_CATERING_STATE')
    if GSXCatering == 1 then GSXCateringTxt = "off"
    elseif GSXCatering == 4 then GSXCateringTxt = "pending"
    elseif GSXCatering == 5 then GSXCateringTxt = "completed"
    elseif GSXCatering == 6 then GSXCateringTxt = "no longer avail"
    else GSXCateringTxt = GSXCatering
    end

    GSXCatTruck1 = ipc.readLvar('FSDT_Catering_truck_catwalk1')
    GSXCatTruck2 = ipc.readLvar('FSDT_Catering_truck_catwalk2')

    CatManCount1 = ipc.get("CatManCount1")
    CatManCount2 = ipc.get("CatManCount2")
    GSXManWalk1 = ipc.readLvar('FSDT_Catering_truck_man1')
    GSXManWalk2 = ipc.readLvar('FSDT_Catering_truck_man2')

    CatPhase1 = ipc.get("CatPhase1")
    CatPhase2 = ipc.get("CatPhase2")


    -- refueling
    GSXTankerVar = ipc.readLvar('FSDT_GSX_REFUELING_STATE')
    if GSXTankerVar == 1 then GSXTankerVarTxt = "off"
    elseif GSXTankerVar == 4 then GSXTankerVarTxt = "pending"
    elseif GSXTankerVar == 5 then GSXTankerVarTxt = "arrived"
    elseif GSXTankerVar == 6 then GSXTankerVarTxt = "completed"
    else GSXTankerVarTxt = GSXTankerVar
    end
    GSXTanker = ipc.get("GSXTanker")
    GSXHoseVar = ipc.readLvar('FSDT_FuelHose')
    GSXFuelTrailerVar = ipc.readLvar('FSDT_FuelTrailerNeedle')
    if GSXRefuelTestTxt == nil then GSXRefuelTestTxt = "failed" end

    -- GSX boarding
    GSXBoardingVar = ipc.readLvar('FSDT_GSX_BOARDING_STATE')
    if GSXBoardingVar == 1 then GSXBoardingVarTxt = "off"
    elseif GSXBoardingVar == 4 then GSXBoardingVarTxt = "pending"
    elseif GSXBoardingVar == 5 then GSXBoardingVarTxt = "boarding"
    elseif GSXBoardingVar == 6 then GSXBoardingVarTxt = "completed"
    else GSXBoardingVarTxt = GSXBoardingVar
    end

    GSXBoard = ipc.get("GSXBoard")


    FSXdoor = ipc.readUB(0x3367)
    if FSXdoor == 0 then FSXdoorTxt = "all closed"
    elseif FSXdoor == 1 then FSXdoorTxt = " 1 open"
    elseif FSXdoor == 2 then FSXdoorTxt = " 2 open"
    elseif FSXdoor == 3 then FSXdoorTxt = " 1 + 2 open"
    elseif FSXdoor == 4 then FSXdoorTxt = " 3 open"
    elseif FSXdoor == 5 then FSXdoorTxt = " 1 + 3 open"
    elseif FSXdoor == 6 then FSXdoorTxt = " 2 + 3 open"
    elseif FSXdoor == 8 then FSXdoorTxt = " 4 open"
    elseif FSXdoor == 9 then FSXdoorTxt = " 1 + 4 open"
    elseif FSXdoor == 10 then FSXdoorTxt = " 1 + 2 open"
    elseif FSXdoor == 12 then FSXdoorTxt = " 1 + 3 open"
    end

    ipc.display(
      "GSX Deboarding State:   " .. GSXdeboardTxt .. " (" .. GSXdeboardingVar .. ")" ..




    "\n\n\nGSX Catering State:       " .. GSXCateringTxt .. " (" .. GSXCatering .. ")" ..

    "\n\n-- GSXCatTruck1    ".. GSXCatTruck1 ..
    "\n-- GSXManWalk1:   " .. GSXManWalk1..
    "\n-- CatManCount1:   " .. CatManCount1 ..
    "\n-- CatPhase1:        " .. CatPhase1 ..

    "\n\n-- GSXCatTruck2    ".. GSXCatTruck2 ..
    "\n-- GSXManWalk2:   " .. GSXManWalk2..
    "\n-- CatManCount2:   " .. CatManCount2 ..
    "\n-- CatPhase2:        " .. CatPhase2 ..


    "\n\n\nGSX Refueling State:      " .. GSXTankerVarTxt .. " (" .. GSXTankerVar .. ")" ..

    "\n\n-- GSXTanker            ".. GSXTanker ..
    "\n-- GSXHoseVar          ".. GSXHoseVar ..
    "\n-- GSXFuelTrailerVar  ".. GSXFuelTrailerVar ..
    "\n-- GSXRefuelTestTxt  ".. GSXRefuelTestTxt ..


    "\n\n\nGSX Boarding State:       " .. GSXBoardingVarTxt .. " (" .. GSXBoardingVar .. ")" ..

    "\n\n-- GSXBoard    ".. GSXBoard ..


    "\n\n\nFSX Doors    ".. FSXdoorTxt)




end

--------------- GSX end
